/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         ir3_yyparse
#define yylex           ir3_yylex
#define yyerror         ir3_yyerror
#define yydebug         ir3_yydebug
#define yynerrs         ir3_yynerrs
#define yylval          ir3_yylval
#define yychar          ir3_yychar

/* First part of user prologue.  */
#line 32 "../src/freedreno/ir3/ir3_parser.y"

#define YYDEBUG 0

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "util/half_float.h"
#include "util/u_math.h"

#include "ir3/ir3.h"
#include "ir3/ir3_shader.h"
#include "ir3/instr-a3xx.h"

#include "ir3_parser.h"

#define swap(a, b) \
	do { __typeof(a) __tmp = (a); (a) = (b); (b) = __tmp; } while (0)

/* ir3 treats the abs/neg flags as separate flags for float vs integer,
 * but in the instruction encoding they are the same thing.  Tracking
 * them separately is only for the benefit of ir3 opt passes, and not
 * required here, so just use the float versions:
 */
#define IR3_REG_ABS     IR3_REG_FABS
#define IR3_REG_NEGATE  IR3_REG_FNEG

static struct ir3_kernel_info    *info;
static struct ir3_shader_variant *variant;
/* NOTE the assembler doesn't really use the ir3_block construction
 * like the compiler does.  Everything is treated as one large block.
 * Which might happen to contain flow control.  But since we don't
 * use any of the ir3 backend passes (sched, RA, etc) this doesn't
 * really matter.
 */
static struct ir3_block          *block;   /* current shader block */
static struct ir3_instruction    *instr;   /* current instruction */
static unsigned ip; /* current instruction pointer */
static struct hash_table *labels;

void *ir3_parser_dead_ctx;

static struct {
	unsigned flags;
	unsigned repeat;
	unsigned nop;
} iflags;

static struct {
	unsigned flags;
	unsigned wrmask;
} rflags;

int ir3_yyget_lineno(void);

static void new_label(const char *name)
{
	ralloc_steal(labels, (void *) name);
	_mesa_hash_table_insert(labels, name, (void *)(uintptr_t)ip);
}

static struct ir3_instruction * new_instr(opc_t opc)
{
	instr = ir3_instr_create(block, opc, 4, 6);
	instr->flags = iflags.flags;
	instr->repeat = iflags.repeat;
	instr->nop = iflags.nop;
	instr->line = ir3_yyget_lineno();
	iflags.flags = iflags.repeat = iflags.nop = 0;
	ip++;
	return instr;
}

static void new_shader(void)
{
	variant->ir = ir3_create(variant->compiler, variant);
	block = ir3_block_create(variant->ir);
	list_addtail(&block->node, &variant->ir->block_list);
	ip = 0;
	labels = _mesa_hash_table_create(variant, _mesa_hash_string, _mesa_key_string_equal);
	ir3_parser_dead_ctx = ralloc_context(NULL);
}

static type_t parse_type(const char **type)
{
	if (!strncmp("f16", *type, 3)) {
		*type += 3;
		return TYPE_F16;
	} else if (!strncmp("f32", *type, 3)) {
		*type += 3;
		return TYPE_F32;
	} else if (!strncmp("u16", *type, 3)) {
		*type += 3;
		return TYPE_U16;
	} else if (!strncmp("u32", *type, 3)) {
		*type += 3;
		return TYPE_U32;
	} else if (!strncmp("s16", *type, 3)) {
		*type += 3;
		return TYPE_S16;
	} else if (!strncmp("s32", *type, 3)) {
		*type += 3;
		return TYPE_S32;
	} else if (!strncmp("u8", *type, 2)) {
		*type += 2;
		return TYPE_U8;
	} else if (!strncmp("s8", *type, 2)) {
		*type += 2;
		return TYPE_S8;
	} else {
		assert(0);  /* shouldn't get here */
		return ~0;
	}
}

static struct ir3_instruction * parse_type_type(struct ir3_instruction *instr,
		const char *type_type)
{
	instr->cat1.src_type = parse_type(&type_type);
	instr->cat1.dst_type = parse_type(&type_type);
	return instr;
}

static struct ir3_register * new_src(int num, unsigned flags)
{
	struct ir3_register *reg;
	flags |= rflags.flags;
	if (num & 0x1)
		flags |= IR3_REG_HALF;
	reg = ir3_src_create(instr, num>>1, flags);
	reg->wrmask = MAX2(1, rflags.wrmask);
	rflags.flags = rflags.wrmask = 0;
	return reg;
}

static struct ir3_register * new_dst(int num, unsigned flags)
{
	struct ir3_register *reg;
	flags |= rflags.flags;
	if (num & 0x1)
		flags |= IR3_REG_HALF;
	reg = ir3_dst_create(instr, num>>1, flags);
	reg->wrmask = MAX2(1, rflags.wrmask);
	rflags.flags = rflags.wrmask = 0;
	return reg;
}

static struct ir3_register * dummy_dst(void)
{
	return new_dst(0, 0);
}

static void fixup_cat5_s2en(void)
{
	assert(opc_cat(instr->opc) == 5);
	if (!(instr->flags & IR3_INSTR_S2EN))
		return;
	/* For various reasons (ie. mainly to make the .s2en src easier to
	 * find, given that various different cat5 tex instructions can have
	 * different # of src registers), in ir3 the samp/tex src register
	 * is first, rather than last.  So we have to detect this case and
	 * fix things up.
	 */
	struct ir3_register *s2en_src = instr->srcs[instr->srcs_count - 1];

	if (instr->flags & IR3_INSTR_B)
		assert(!(s2en_src->flags & IR3_REG_HALF));
	else
		assert(s2en_src->flags & IR3_REG_HALF);

	for (int i = 0; i < instr->srcs_count - 1; i++) {
		instr->srcs[i+1] = instr->srcs[i];
	}
	instr->srcs[0] = s2en_src;
}

static void add_const(unsigned reg, unsigned c0, unsigned c1, unsigned c2, unsigned c3)
{
	struct ir3_const_state *const_state = ir3_const_state(variant);
	assert((reg & 0x7) == 0);
	int idx = reg >> (1 + 2); /* low bit is half vs full, next two bits are swiz */
	if (idx * 4 + 4 > const_state->immediates_size) {
		const_state->immediates = rerzalloc(const_state,
				const_state->immediates,
				__typeof__(const_state->immediates[0]),
				const_state->immediates_size,
				idx * 4 + 4);
		for (unsigned i = const_state->immediates_size; i < idx * 4; i++)
			const_state->immediates[i] = 0xd0d0d0d0;
		const_state->immediates_size = const_state->immediates_count = idx * 4 + 4;
	}
	const_state->immediates[idx * 4 + 0] = c0;
	const_state->immediates[idx * 4 + 1] = c1;
	const_state->immediates[idx * 4 + 2] = c2;
	const_state->immediates[idx * 4 + 3] = c3;
}

static void add_sysval(unsigned reg, unsigned compmask, gl_system_value sysval)
{
	unsigned n = variant->inputs_count++;
	variant->inputs[n].regid = reg;
	variant->inputs[n].sysval = true;
	variant->inputs[n].slot = sysval;
	variant->inputs[n].compmask = compmask;
	variant->total_in++;
}

static bool resolve_labels(void)
{
	int instr_ip = 0;
	foreach_instr (instr, &block->instr_list) {
		if (opc_cat(instr->opc) == 0 && instr->cat0.target_label) {
			struct hash_entry *entry = _mesa_hash_table_search(labels, instr->cat0.target_label);
			if (!entry) {
				fprintf(stderr, "unknown label %s\n", instr->cat0.target_label);
				return false;
			}
			int target_ip = (uintptr_t)entry->data;
			instr->cat0.immed = target_ip - instr_ip;
		}
		instr_ip++;
	}
	return true;
}

#ifdef YYDEBUG
int yydebug;
#endif

extern int yylex(void);
void ir3_yyset_lineno(int _line_number);
void ir3_yyset_input(FILE *f);

int yyparse(void);

static void yyerror(const char *error)
{
	fprintf(stderr, "error at line %d: %s\n", ir3_yyget_lineno(), error);
}

struct ir3 * ir3_parse(struct ir3_shader_variant *v,
		struct ir3_kernel_info *k, FILE *f)
{
	ir3_yyset_lineno(1);
	ir3_yyset_input(f);
#ifdef YYDEBUG
	yydebug = 1;
#endif
	info = k;
	variant = v;
	if (yyparse() || !resolve_labels()) {
		ir3_destroy(variant->ir);
		variant->ir = NULL;
	}
	ralloc_free(labels);
	ralloc_free(ir3_parser_dead_ctx);
	return variant->ir;
}

#line 339 "src/freedreno/ir3/ir3_parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "ir3_parser.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_T_INT = 3,                      /* T_INT  */
  YYSYMBOL_T_HEX = 4,                      /* T_HEX  */
  YYSYMBOL_T_FLOAT = 5,                    /* T_FLOAT  */
  YYSYMBOL_T_IDENTIFIER = 6,               /* T_IDENTIFIER  */
  YYSYMBOL_T_REGISTER = 7,                 /* T_REGISTER  */
  YYSYMBOL_T_CONSTANT = 8,                 /* T_CONSTANT  */
  YYSYMBOL_T_A_LOCALSIZE = 9,              /* T_A_LOCALSIZE  */
  YYSYMBOL_T_A_CONST = 10,                 /* T_A_CONST  */
  YYSYMBOL_T_A_BUF = 11,                   /* T_A_BUF  */
  YYSYMBOL_T_A_INVOCATIONID = 12,          /* T_A_INVOCATIONID  */
  YYSYMBOL_T_A_WGID = 13,                  /* T_A_WGID  */
  YYSYMBOL_T_A_NUMWG = 14,                 /* T_A_NUMWG  */
  YYSYMBOL_T_A_BRANCHSTACK = 15,           /* T_A_BRANCHSTACK  */
  YYSYMBOL_T_A_IN = 16,                    /* T_A_IN  */
  YYSYMBOL_T_A_OUT = 17,                   /* T_A_OUT  */
  YYSYMBOL_T_A_TEX = 18,                   /* T_A_TEX  */
  YYSYMBOL_T_A_PVTMEM = 19,                /* T_A_PVTMEM  */
  YYSYMBOL_T_A_EARLYPREAMBLE = 20,         /* T_A_EARLYPREAMBLE  */
  YYSYMBOL_T_ABSNEG = 21,                  /* T_ABSNEG  */
  YYSYMBOL_T_NEG = 22,                     /* T_NEG  */
  YYSYMBOL_T_ABS = 23,                     /* T_ABS  */
  YYSYMBOL_T_R = 24,                       /* T_R  */
  YYSYMBOL_T_LAST = 25,                    /* T_LAST  */
  YYSYMBOL_T_HR = 26,                      /* T_HR  */
  YYSYMBOL_T_HC = 27,                      /* T_HC  */
  YYSYMBOL_T_EVEN = 28,                    /* T_EVEN  */
  YYSYMBOL_T_POS_INFINITY = 29,            /* T_POS_INFINITY  */
  YYSYMBOL_T_NEG_INFINITY = 30,            /* T_NEG_INFINITY  */
  YYSYMBOL_T_EI = 31,                      /* T_EI  */
  YYSYMBOL_T_WRMASK = 32,                  /* T_WRMASK  */
  YYSYMBOL_T_FLUT_0_0 = 33,                /* T_FLUT_0_0  */
  YYSYMBOL_T_FLUT_0_5 = 34,                /* T_FLUT_0_5  */
  YYSYMBOL_T_FLUT_1_0 = 35,                /* T_FLUT_1_0  */
  YYSYMBOL_T_FLUT_2_0 = 36,                /* T_FLUT_2_0  */
  YYSYMBOL_T_FLUT_E = 37,                  /* T_FLUT_E  */
  YYSYMBOL_T_FLUT_PI = 38,                 /* T_FLUT_PI  */
  YYSYMBOL_T_FLUT_INV_PI = 39,             /* T_FLUT_INV_PI  */
  YYSYMBOL_T_FLUT_INV_LOG2_E = 40,         /* T_FLUT_INV_LOG2_E  */
  YYSYMBOL_T_FLUT_LOG2_E = 41,             /* T_FLUT_LOG2_E  */
  YYSYMBOL_T_FLUT_INV_LOG2_10 = 42,        /* T_FLUT_INV_LOG2_10  */
  YYSYMBOL_T_FLUT_LOG2_10 = 43,            /* T_FLUT_LOG2_10  */
  YYSYMBOL_T_FLUT_4_0 = 44,                /* T_FLUT_4_0  */
  YYSYMBOL_T_SY = 45,                      /* T_SY  */
  YYSYMBOL_T_SS = 46,                      /* T_SS  */
  YYSYMBOL_T_JP = 47,                      /* T_JP  */
  YYSYMBOL_T_EQ_FLAG = 48,                 /* T_EQ_FLAG  */
  YYSYMBOL_T_SAT = 49,                     /* T_SAT  */
  YYSYMBOL_T_RPT = 50,                     /* T_RPT  */
  YYSYMBOL_T_UL = 51,                      /* T_UL  */
  YYSYMBOL_T_NOP = 52,                     /* T_NOP  */
  YYSYMBOL_T_OP_NOP = 53,                  /* T_OP_NOP  */
  YYSYMBOL_T_OP_BR = 54,                   /* T_OP_BR  */
  YYSYMBOL_T_OP_BRAO = 55,                 /* T_OP_BRAO  */
  YYSYMBOL_T_OP_BRAA = 56,                 /* T_OP_BRAA  */
  YYSYMBOL_T_OP_BRAC = 57,                 /* T_OP_BRAC  */
  YYSYMBOL_T_OP_BANY = 58,                 /* T_OP_BANY  */
  YYSYMBOL_T_OP_BALL = 59,                 /* T_OP_BALL  */
  YYSYMBOL_T_OP_BRAX = 60,                 /* T_OP_BRAX  */
  YYSYMBOL_T_OP_JUMP = 61,                 /* T_OP_JUMP  */
  YYSYMBOL_T_OP_CALL = 62,                 /* T_OP_CALL  */
  YYSYMBOL_T_OP_RET = 63,                  /* T_OP_RET  */
  YYSYMBOL_T_OP_KILL = 64,                 /* T_OP_KILL  */
  YYSYMBOL_T_OP_END = 65,                  /* T_OP_END  */
  YYSYMBOL_T_OP_EMIT = 66,                 /* T_OP_EMIT  */
  YYSYMBOL_T_OP_CUT = 67,                  /* T_OP_CUT  */
  YYSYMBOL_T_OP_CHMASK = 68,               /* T_OP_CHMASK  */
  YYSYMBOL_T_OP_CHSH = 69,                 /* T_OP_CHSH  */
  YYSYMBOL_T_OP_FLOW_REV = 70,             /* T_OP_FLOW_REV  */
  YYSYMBOL_T_OP_BKT = 71,                  /* T_OP_BKT  */
  YYSYMBOL_T_OP_STKS = 72,                 /* T_OP_STKS  */
  YYSYMBOL_T_OP_STKR = 73,                 /* T_OP_STKR  */
  YYSYMBOL_T_OP_XSET = 74,                 /* T_OP_XSET  */
  YYSYMBOL_T_OP_XCLR = 75,                 /* T_OP_XCLR  */
  YYSYMBOL_T_OP_GETLAST = 76,              /* T_OP_GETLAST  */
  YYSYMBOL_T_OP_GETONE = 77,               /* T_OP_GETONE  */
  YYSYMBOL_T_OP_DBG = 78,                  /* T_OP_DBG  */
  YYSYMBOL_T_OP_SHPS = 79,                 /* T_OP_SHPS  */
  YYSYMBOL_T_OP_SHPE = 80,                 /* T_OP_SHPE  */
  YYSYMBOL_T_OP_PREDT = 81,                /* T_OP_PREDT  */
  YYSYMBOL_T_OP_PREDF = 82,                /* T_OP_PREDF  */
  YYSYMBOL_T_OP_PREDE = 83,                /* T_OP_PREDE  */
  YYSYMBOL_T_OP_MOVMSK = 84,               /* T_OP_MOVMSK  */
  YYSYMBOL_T_OP_MOVA1 = 85,                /* T_OP_MOVA1  */
  YYSYMBOL_T_OP_MOVA = 86,                 /* T_OP_MOVA  */
  YYSYMBOL_T_OP_MOV = 87,                  /* T_OP_MOV  */
  YYSYMBOL_T_OP_COV = 88,                  /* T_OP_COV  */
  YYSYMBOL_T_OP_SWZ = 89,                  /* T_OP_SWZ  */
  YYSYMBOL_T_OP_GAT = 90,                  /* T_OP_GAT  */
  YYSYMBOL_T_OP_SCT = 91,                  /* T_OP_SCT  */
  YYSYMBOL_T_OP_ADD_F = 92,                /* T_OP_ADD_F  */
  YYSYMBOL_T_OP_MIN_F = 93,                /* T_OP_MIN_F  */
  YYSYMBOL_T_OP_MAX_F = 94,                /* T_OP_MAX_F  */
  YYSYMBOL_T_OP_MUL_F = 95,                /* T_OP_MUL_F  */
  YYSYMBOL_T_OP_SIGN_F = 96,               /* T_OP_SIGN_F  */
  YYSYMBOL_T_OP_CMPS_F = 97,               /* T_OP_CMPS_F  */
  YYSYMBOL_T_OP_ABSNEG_F = 98,             /* T_OP_ABSNEG_F  */
  YYSYMBOL_T_OP_CMPV_F = 99,               /* T_OP_CMPV_F  */
  YYSYMBOL_T_OP_FLOOR_F = 100,             /* T_OP_FLOOR_F  */
  YYSYMBOL_T_OP_CEIL_F = 101,              /* T_OP_CEIL_F  */
  YYSYMBOL_T_OP_RNDNE_F = 102,             /* T_OP_RNDNE_F  */
  YYSYMBOL_T_OP_RNDAZ_F = 103,             /* T_OP_RNDAZ_F  */
  YYSYMBOL_T_OP_TRUNC_F = 104,             /* T_OP_TRUNC_F  */
  YYSYMBOL_T_OP_ADD_U = 105,               /* T_OP_ADD_U  */
  YYSYMBOL_T_OP_ADD_S = 106,               /* T_OP_ADD_S  */
  YYSYMBOL_T_OP_SUB_U = 107,               /* T_OP_SUB_U  */
  YYSYMBOL_T_OP_SUB_S = 108,               /* T_OP_SUB_S  */
  YYSYMBOL_T_OP_CMPS_U = 109,              /* T_OP_CMPS_U  */
  YYSYMBOL_T_OP_CMPS_S = 110,              /* T_OP_CMPS_S  */
  YYSYMBOL_T_OP_MIN_U = 111,               /* T_OP_MIN_U  */
  YYSYMBOL_T_OP_MIN_S = 112,               /* T_OP_MIN_S  */
  YYSYMBOL_T_OP_MAX_U = 113,               /* T_OP_MAX_U  */
  YYSYMBOL_T_OP_MAX_S = 114,               /* T_OP_MAX_S  */
  YYSYMBOL_T_OP_ABSNEG_S = 115,            /* T_OP_ABSNEG_S  */
  YYSYMBOL_T_OP_AND_B = 116,               /* T_OP_AND_B  */
  YYSYMBOL_T_OP_OR_B = 117,                /* T_OP_OR_B  */
  YYSYMBOL_T_OP_NOT_B = 118,               /* T_OP_NOT_B  */
  YYSYMBOL_T_OP_XOR_B = 119,               /* T_OP_XOR_B  */
  YYSYMBOL_T_OP_CMPV_U = 120,              /* T_OP_CMPV_U  */
  YYSYMBOL_T_OP_CMPV_S = 121,              /* T_OP_CMPV_S  */
  YYSYMBOL_T_OP_MUL_U24 = 122,             /* T_OP_MUL_U24  */
  YYSYMBOL_T_OP_MUL_S24 = 123,             /* T_OP_MUL_S24  */
  YYSYMBOL_T_OP_MULL_U = 124,              /* T_OP_MULL_U  */
  YYSYMBOL_T_OP_BFREV_B = 125,             /* T_OP_BFREV_B  */
  YYSYMBOL_T_OP_CLZ_S = 126,               /* T_OP_CLZ_S  */
  YYSYMBOL_T_OP_CLZ_B = 127,               /* T_OP_CLZ_B  */
  YYSYMBOL_T_OP_SHL_B = 128,               /* T_OP_SHL_B  */
  YYSYMBOL_T_OP_SHR_B = 129,               /* T_OP_SHR_B  */
  YYSYMBOL_T_OP_ASHR_B = 130,              /* T_OP_ASHR_B  */
  YYSYMBOL_T_OP_BARY_F = 131,              /* T_OP_BARY_F  */
  YYSYMBOL_T_OP_FLAT_B = 132,              /* T_OP_FLAT_B  */
  YYSYMBOL_T_OP_MGEN_B = 133,              /* T_OP_MGEN_B  */
  YYSYMBOL_T_OP_GETBIT_B = 134,            /* T_OP_GETBIT_B  */
  YYSYMBOL_T_OP_SETRM = 135,               /* T_OP_SETRM  */
  YYSYMBOL_T_OP_CBITS_B = 136,             /* T_OP_CBITS_B  */
  YYSYMBOL_T_OP_SHB = 137,                 /* T_OP_SHB  */
  YYSYMBOL_T_OP_MSAD = 138,                /* T_OP_MSAD  */
  YYSYMBOL_T_OP_MAD_U16 = 139,             /* T_OP_MAD_U16  */
  YYSYMBOL_T_OP_MADSH_U16 = 140,           /* T_OP_MADSH_U16  */
  YYSYMBOL_T_OP_MAD_S16 = 141,             /* T_OP_MAD_S16  */
  YYSYMBOL_T_OP_MADSH_M16 = 142,           /* T_OP_MADSH_M16  */
  YYSYMBOL_T_OP_MAD_U24 = 143,             /* T_OP_MAD_U24  */
  YYSYMBOL_T_OP_MAD_S24 = 144,             /* T_OP_MAD_S24  */
  YYSYMBOL_T_OP_MAD_F16 = 145,             /* T_OP_MAD_F16  */
  YYSYMBOL_T_OP_MAD_F32 = 146,             /* T_OP_MAD_F32  */
  YYSYMBOL_T_OP_SEL_B16 = 147,             /* T_OP_SEL_B16  */
  YYSYMBOL_T_OP_SEL_B32 = 148,             /* T_OP_SEL_B32  */
  YYSYMBOL_T_OP_SEL_S16 = 149,             /* T_OP_SEL_S16  */
  YYSYMBOL_T_OP_SEL_S32 = 150,             /* T_OP_SEL_S32  */
  YYSYMBOL_T_OP_SEL_F16 = 151,             /* T_OP_SEL_F16  */
  YYSYMBOL_T_OP_SEL_F32 = 152,             /* T_OP_SEL_F32  */
  YYSYMBOL_T_OP_SAD_S16 = 153,             /* T_OP_SAD_S16  */
  YYSYMBOL_T_OP_SAD_S32 = 154,             /* T_OP_SAD_S32  */
  YYSYMBOL_T_OP_SHRM = 155,                /* T_OP_SHRM  */
  YYSYMBOL_T_OP_SHLM = 156,                /* T_OP_SHLM  */
  YYSYMBOL_T_OP_SHRG = 157,                /* T_OP_SHRG  */
  YYSYMBOL_T_OP_SHLG = 158,                /* T_OP_SHLG  */
  YYSYMBOL_T_OP_ANDG = 159,                /* T_OP_ANDG  */
  YYSYMBOL_T_OP_DP2ACC = 160,              /* T_OP_DP2ACC  */
  YYSYMBOL_T_OP_DP4ACC = 161,              /* T_OP_DP4ACC  */
  YYSYMBOL_T_OP_WMM = 162,                 /* T_OP_WMM  */
  YYSYMBOL_T_OP_WMM_ACCU = 163,            /* T_OP_WMM_ACCU  */
  YYSYMBOL_T_OP_RCP = 164,                 /* T_OP_RCP  */
  YYSYMBOL_T_OP_RSQ = 165,                 /* T_OP_RSQ  */
  YYSYMBOL_T_OP_LOG2 = 166,                /* T_OP_LOG2  */
  YYSYMBOL_T_OP_EXP2 = 167,                /* T_OP_EXP2  */
  YYSYMBOL_T_OP_SIN = 168,                 /* T_OP_SIN  */
  YYSYMBOL_T_OP_COS = 169,                 /* T_OP_COS  */
  YYSYMBOL_T_OP_SQRT = 170,                /* T_OP_SQRT  */
  YYSYMBOL_T_OP_HRSQ = 171,                /* T_OP_HRSQ  */
  YYSYMBOL_T_OP_HLOG2 = 172,               /* T_OP_HLOG2  */
  YYSYMBOL_T_OP_HEXP2 = 173,               /* T_OP_HEXP2  */
  YYSYMBOL_T_OP_ISAM = 174,                /* T_OP_ISAM  */
  YYSYMBOL_T_OP_ISAML = 175,               /* T_OP_ISAML  */
  YYSYMBOL_T_OP_ISAMM = 176,               /* T_OP_ISAMM  */
  YYSYMBOL_T_OP_SAM = 177,                 /* T_OP_SAM  */
  YYSYMBOL_T_OP_SAMB = 178,                /* T_OP_SAMB  */
  YYSYMBOL_T_OP_SAML = 179,                /* T_OP_SAML  */
  YYSYMBOL_T_OP_SAMGQ = 180,               /* T_OP_SAMGQ  */
  YYSYMBOL_T_OP_GETLOD = 181,              /* T_OP_GETLOD  */
  YYSYMBOL_T_OP_CONV = 182,                /* T_OP_CONV  */
  YYSYMBOL_T_OP_CONVM = 183,               /* T_OP_CONVM  */
  YYSYMBOL_T_OP_GETSIZE = 184,             /* T_OP_GETSIZE  */
  YYSYMBOL_T_OP_GETBUF = 185,              /* T_OP_GETBUF  */
  YYSYMBOL_T_OP_GETPOS = 186,              /* T_OP_GETPOS  */
  YYSYMBOL_T_OP_GETINFO = 187,             /* T_OP_GETINFO  */
  YYSYMBOL_T_OP_DSX = 188,                 /* T_OP_DSX  */
  YYSYMBOL_T_OP_DSY = 189,                 /* T_OP_DSY  */
  YYSYMBOL_T_OP_GATHER4R = 190,            /* T_OP_GATHER4R  */
  YYSYMBOL_T_OP_GATHER4G = 191,            /* T_OP_GATHER4G  */
  YYSYMBOL_T_OP_GATHER4B = 192,            /* T_OP_GATHER4B  */
  YYSYMBOL_T_OP_GATHER4A = 193,            /* T_OP_GATHER4A  */
  YYSYMBOL_T_OP_SAMGP0 = 194,              /* T_OP_SAMGP0  */
  YYSYMBOL_T_OP_SAMGP1 = 195,              /* T_OP_SAMGP1  */
  YYSYMBOL_T_OP_SAMGP2 = 196,              /* T_OP_SAMGP2  */
  YYSYMBOL_T_OP_SAMGP3 = 197,              /* T_OP_SAMGP3  */
  YYSYMBOL_T_OP_DSXPP_1 = 198,             /* T_OP_DSXPP_1  */
  YYSYMBOL_T_OP_DSYPP_1 = 199,             /* T_OP_DSYPP_1  */
  YYSYMBOL_T_OP_RGETPOS = 200,             /* T_OP_RGETPOS  */
  YYSYMBOL_T_OP_RGETINFO = 201,            /* T_OP_RGETINFO  */
  YYSYMBOL_T_OP_BRCST_A = 202,             /* T_OP_BRCST_A  */
  YYSYMBOL_T_OP_QSHUFFLE_BRCST = 203,      /* T_OP_QSHUFFLE_BRCST  */
  YYSYMBOL_T_OP_QSHUFFLE_H = 204,          /* T_OP_QSHUFFLE_H  */
  YYSYMBOL_T_OP_QSHUFFLE_V = 205,          /* T_OP_QSHUFFLE_V  */
  YYSYMBOL_T_OP_QSHUFFLE_DIAG = 206,       /* T_OP_QSHUFFLE_DIAG  */
  YYSYMBOL_T_OP_TCINV = 207,               /* T_OP_TCINV  */
  YYSYMBOL_T_OP_LDG = 208,                 /* T_OP_LDG  */
  YYSYMBOL_T_OP_LDG_A = 209,               /* T_OP_LDG_A  */
  YYSYMBOL_T_OP_LDL = 210,                 /* T_OP_LDL  */
  YYSYMBOL_T_OP_LDP = 211,                 /* T_OP_LDP  */
  YYSYMBOL_T_OP_STG = 212,                 /* T_OP_STG  */
  YYSYMBOL_T_OP_STG_A = 213,               /* T_OP_STG_A  */
  YYSYMBOL_T_OP_STL = 214,                 /* T_OP_STL  */
  YYSYMBOL_T_OP_STP = 215,                 /* T_OP_STP  */
  YYSYMBOL_T_OP_LDIB = 216,                /* T_OP_LDIB  */
  YYSYMBOL_T_OP_G2L = 217,                 /* T_OP_G2L  */
  YYSYMBOL_T_OP_L2G = 218,                 /* T_OP_L2G  */
  YYSYMBOL_T_OP_PREFETCH = 219,            /* T_OP_PREFETCH  */
  YYSYMBOL_T_OP_LDLW = 220,                /* T_OP_LDLW  */
  YYSYMBOL_T_OP_STLW = 221,                /* T_OP_STLW  */
  YYSYMBOL_T_OP_RESFMT = 222,              /* T_OP_RESFMT  */
  YYSYMBOL_T_OP_RESINFO = 223,             /* T_OP_RESINFO  */
  YYSYMBOL_T_OP_ATOMIC_ADD = 224,          /* T_OP_ATOMIC_ADD  */
  YYSYMBOL_T_OP_ATOMIC_SUB = 225,          /* T_OP_ATOMIC_SUB  */
  YYSYMBOL_T_OP_ATOMIC_XCHG = 226,         /* T_OP_ATOMIC_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_INC = 227,          /* T_OP_ATOMIC_INC  */
  YYSYMBOL_T_OP_ATOMIC_DEC = 228,          /* T_OP_ATOMIC_DEC  */
  YYSYMBOL_T_OP_ATOMIC_CMPXCHG = 229,      /* T_OP_ATOMIC_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_MIN = 230,          /* T_OP_ATOMIC_MIN  */
  YYSYMBOL_T_OP_ATOMIC_MAX = 231,          /* T_OP_ATOMIC_MAX  */
  YYSYMBOL_T_OP_ATOMIC_AND = 232,          /* T_OP_ATOMIC_AND  */
  YYSYMBOL_T_OP_ATOMIC_OR = 233,           /* T_OP_ATOMIC_OR  */
  YYSYMBOL_T_OP_ATOMIC_XOR = 234,          /* T_OP_ATOMIC_XOR  */
  YYSYMBOL_T_OP_RESINFO_B = 235,           /* T_OP_RESINFO_B  */
  YYSYMBOL_T_OP_LDIB_B = 236,              /* T_OP_LDIB_B  */
  YYSYMBOL_T_OP_STIB_B = 237,              /* T_OP_STIB_B  */
  YYSYMBOL_T_OP_ATOMIC_B_ADD = 238,        /* T_OP_ATOMIC_B_ADD  */
  YYSYMBOL_T_OP_ATOMIC_B_SUB = 239,        /* T_OP_ATOMIC_B_SUB  */
  YYSYMBOL_T_OP_ATOMIC_B_XCHG = 240,       /* T_OP_ATOMIC_B_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_B_INC = 241,        /* T_OP_ATOMIC_B_INC  */
  YYSYMBOL_T_OP_ATOMIC_B_DEC = 242,        /* T_OP_ATOMIC_B_DEC  */
  YYSYMBOL_T_OP_ATOMIC_B_CMPXCHG = 243,    /* T_OP_ATOMIC_B_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_B_MIN = 244,        /* T_OP_ATOMIC_B_MIN  */
  YYSYMBOL_T_OP_ATOMIC_B_MAX = 245,        /* T_OP_ATOMIC_B_MAX  */
  YYSYMBOL_T_OP_ATOMIC_B_AND = 246,        /* T_OP_ATOMIC_B_AND  */
  YYSYMBOL_T_OP_ATOMIC_B_OR = 247,         /* T_OP_ATOMIC_B_OR  */
  YYSYMBOL_T_OP_ATOMIC_B_XOR = 248,        /* T_OP_ATOMIC_B_XOR  */
  YYSYMBOL_T_OP_ATOMIC_S_ADD = 249,        /* T_OP_ATOMIC_S_ADD  */
  YYSYMBOL_T_OP_ATOMIC_S_SUB = 250,        /* T_OP_ATOMIC_S_SUB  */
  YYSYMBOL_T_OP_ATOMIC_S_XCHG = 251,       /* T_OP_ATOMIC_S_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_S_INC = 252,        /* T_OP_ATOMIC_S_INC  */
  YYSYMBOL_T_OP_ATOMIC_S_DEC = 253,        /* T_OP_ATOMIC_S_DEC  */
  YYSYMBOL_T_OP_ATOMIC_S_CMPXCHG = 254,    /* T_OP_ATOMIC_S_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_S_MIN = 255,        /* T_OP_ATOMIC_S_MIN  */
  YYSYMBOL_T_OP_ATOMIC_S_MAX = 256,        /* T_OP_ATOMIC_S_MAX  */
  YYSYMBOL_T_OP_ATOMIC_S_AND = 257,        /* T_OP_ATOMIC_S_AND  */
  YYSYMBOL_T_OP_ATOMIC_S_OR = 258,         /* T_OP_ATOMIC_S_OR  */
  YYSYMBOL_T_OP_ATOMIC_S_XOR = 259,        /* T_OP_ATOMIC_S_XOR  */
  YYSYMBOL_T_OP_ATOMIC_G_ADD = 260,        /* T_OP_ATOMIC_G_ADD  */
  YYSYMBOL_T_OP_ATOMIC_G_SUB = 261,        /* T_OP_ATOMIC_G_SUB  */
  YYSYMBOL_T_OP_ATOMIC_G_XCHG = 262,       /* T_OP_ATOMIC_G_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_G_INC = 263,        /* T_OP_ATOMIC_G_INC  */
  YYSYMBOL_T_OP_ATOMIC_G_DEC = 264,        /* T_OP_ATOMIC_G_DEC  */
  YYSYMBOL_T_OP_ATOMIC_G_CMPXCHG = 265,    /* T_OP_ATOMIC_G_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_G_MIN = 266,        /* T_OP_ATOMIC_G_MIN  */
  YYSYMBOL_T_OP_ATOMIC_G_MAX = 267,        /* T_OP_ATOMIC_G_MAX  */
  YYSYMBOL_T_OP_ATOMIC_G_AND = 268,        /* T_OP_ATOMIC_G_AND  */
  YYSYMBOL_T_OP_ATOMIC_G_OR = 269,         /* T_OP_ATOMIC_G_OR  */
  YYSYMBOL_T_OP_ATOMIC_G_XOR = 270,        /* T_OP_ATOMIC_G_XOR  */
  YYSYMBOL_T_OP_LDGB = 271,                /* T_OP_LDGB  */
  YYSYMBOL_T_OP_STGB = 272,                /* T_OP_STGB  */
  YYSYMBOL_T_OP_STIB = 273,                /* T_OP_STIB  */
  YYSYMBOL_T_OP_LDC = 274,                 /* T_OP_LDC  */
  YYSYMBOL_T_OP_LDLV = 275,                /* T_OP_LDLV  */
  YYSYMBOL_T_OP_GETSPID = 276,             /* T_OP_GETSPID  */
  YYSYMBOL_T_OP_GETWID = 277,              /* T_OP_GETWID  */
  YYSYMBOL_T_OP_GETFIBERID = 278,          /* T_OP_GETFIBERID  */
  YYSYMBOL_T_OP_STC = 279,                 /* T_OP_STC  */
  YYSYMBOL_T_OP_STSC = 280,                /* T_OP_STSC  */
  YYSYMBOL_T_OP_BAR = 281,                 /* T_OP_BAR  */
  YYSYMBOL_T_OP_FENCE = 282,               /* T_OP_FENCE  */
  YYSYMBOL_T_OP_SLEEP = 283,               /* T_OP_SLEEP  */
  YYSYMBOL_T_OP_ICINV = 284,               /* T_OP_ICINV  */
  YYSYMBOL_T_OP_DCCLN = 285,               /* T_OP_DCCLN  */
  YYSYMBOL_T_OP_DCINV = 286,               /* T_OP_DCINV  */
  YYSYMBOL_T_OP_DCFLU = 287,               /* T_OP_DCFLU  */
  YYSYMBOL_T_OP_LOCK = 288,                /* T_OP_LOCK  */
  YYSYMBOL_T_OP_UNLOCK = 289,              /* T_OP_UNLOCK  */
  YYSYMBOL_T_OP_ALIAS = 290,               /* T_OP_ALIAS  */
  YYSYMBOL_T_RAW = 291,                    /* T_RAW  */
  YYSYMBOL_T_TYPE_F16 = 292,               /* T_TYPE_F16  */
  YYSYMBOL_T_TYPE_F32 = 293,               /* T_TYPE_F32  */
  YYSYMBOL_T_TYPE_U16 = 294,               /* T_TYPE_U16  */
  YYSYMBOL_T_TYPE_U32 = 295,               /* T_TYPE_U32  */
  YYSYMBOL_T_TYPE_S16 = 296,               /* T_TYPE_S16  */
  YYSYMBOL_T_TYPE_S32 = 297,               /* T_TYPE_S32  */
  YYSYMBOL_T_TYPE_U8 = 298,                /* T_TYPE_U8  */
  YYSYMBOL_T_TYPE_S8 = 299,                /* T_TYPE_S8  */
  YYSYMBOL_T_UNTYPED = 300,                /* T_UNTYPED  */
  YYSYMBOL_T_TYPED = 301,                  /* T_TYPED  */
  YYSYMBOL_T_MIXED = 302,                  /* T_MIXED  */
  YYSYMBOL_T_UNSIGNED = 303,               /* T_UNSIGNED  */
  YYSYMBOL_T_LOW = 304,                    /* T_LOW  */
  YYSYMBOL_T_HIGH = 305,                   /* T_HIGH  */
  YYSYMBOL_T_1D = 306,                     /* T_1D  */
  YYSYMBOL_T_2D = 307,                     /* T_2D  */
  YYSYMBOL_T_3D = 308,                     /* T_3D  */
  YYSYMBOL_T_4D = 309,                     /* T_4D  */
  YYSYMBOL_T_LT = 310,                     /* T_LT  */
  YYSYMBOL_T_LE = 311,                     /* T_LE  */
  YYSYMBOL_T_GT = 312,                     /* T_GT  */
  YYSYMBOL_T_GE = 313,                     /* T_GE  */
  YYSYMBOL_T_EQ = 314,                     /* T_EQ  */
  YYSYMBOL_T_NE = 315,                     /* T_NE  */
  YYSYMBOL_T_S2EN = 316,                   /* T_S2EN  */
  YYSYMBOL_T_SAMP = 317,                   /* T_SAMP  */
  YYSYMBOL_T_TEX = 318,                    /* T_TEX  */
  YYSYMBOL_T_BASE = 319,                   /* T_BASE  */
  YYSYMBOL_T_OFFSET = 320,                 /* T_OFFSET  */
  YYSYMBOL_T_UNIFORM = 321,                /* T_UNIFORM  */
  YYSYMBOL_T_NONUNIFORM = 322,             /* T_NONUNIFORM  */
  YYSYMBOL_T_IMM = 323,                    /* T_IMM  */
  YYSYMBOL_T_NAN = 324,                    /* T_NAN  */
  YYSYMBOL_T_INF = 325,                    /* T_INF  */
  YYSYMBOL_T_A0 = 326,                     /* T_A0  */
  YYSYMBOL_T_A1 = 327,                     /* T_A1  */
  YYSYMBOL_T_P0 = 328,                     /* T_P0  */
  YYSYMBOL_T_W = 329,                      /* T_W  */
  YYSYMBOL_T_CAT1_TYPE_TYPE = 330,         /* T_CAT1_TYPE_TYPE  */
  YYSYMBOL_T_INSTR_TYPE = 331,             /* T_INSTR_TYPE  */
  YYSYMBOL_T_MOD_TEX = 332,                /* T_MOD_TEX  */
  YYSYMBOL_T_MOD_MEM = 333,                /* T_MOD_MEM  */
  YYSYMBOL_T_MOD_RT = 334,                 /* T_MOD_RT  */
  YYSYMBOL_335_ = 335,                     /* '-'  */
  YYSYMBOL_336_ = 336,                     /* ','  */
  YYSYMBOL_337_ = 337,                     /* '('  */
  YYSYMBOL_338_ = 338,                     /* ')'  */
  YYSYMBOL_339_ = 339,                     /* '='  */
  YYSYMBOL_340_ = 340,                     /* ':'  */
  YYSYMBOL_341_ = 341,                     /* '!'  */
  YYSYMBOL_342_ = 342,                     /* '#'  */
  YYSYMBOL_343_ = 343,                     /* '.'  */
  YYSYMBOL_344_a_ = 344,                   /* 'a'  */
  YYSYMBOL_345_o_ = 345,                   /* 'o'  */
  YYSYMBOL_346_p_ = 346,                   /* 'p'  */
  YYSYMBOL_347_s_ = 347,                   /* 's'  */
  YYSYMBOL_348_ = 348,                     /* '+'  */
  YYSYMBOL_349_ = 349,                     /* '<'  */
  YYSYMBOL_350_g_ = 350,                   /* 'g'  */
  YYSYMBOL_351_ = 351,                     /* '['  */
  YYSYMBOL_352_ = 352,                     /* ']'  */
  YYSYMBOL_353_l_ = 353,                   /* 'l'  */
  YYSYMBOL_354_k_ = 354,                   /* 'k'  */
  YYSYMBOL_355_c_ = 355,                   /* 'c'  */
  YYSYMBOL_356_w_ = 356,                   /* 'w'  */
  YYSYMBOL_357_r_ = 357,                   /* 'r'  */
  YYSYMBOL_358_ = 358,                     /* '>'  */
  YYSYMBOL_359_h_ = 359,                   /* 'h'  */
  YYSYMBOL_YYACCEPT = 360,                 /* $accept  */
  YYSYMBOL_shader = 361,                   /* shader  */
  YYSYMBOL_362_1 = 362,                    /* $@1  */
  YYSYMBOL_headers = 363,                  /* headers  */
  YYSYMBOL_header = 364,                   /* header  */
  YYSYMBOL_const_val = 365,                /* const_val  */
  YYSYMBOL_localsize_header = 366,         /* localsize_header  */
  YYSYMBOL_const_header = 367,             /* const_header  */
  YYSYMBOL_buf_header_addr_reg = 368,      /* buf_header_addr_reg  */
  YYSYMBOL_buf_header = 369,               /* buf_header  */
  YYSYMBOL_370_2 = 370,                    /* $@2  */
  YYSYMBOL_invocationid_header = 371,      /* invocationid_header  */
  YYSYMBOL_wgid_header = 372,              /* wgid_header  */
  YYSYMBOL_numwg_header = 373,             /* numwg_header  */
  YYSYMBOL_branchstack_header = 374,       /* branchstack_header  */
  YYSYMBOL_pvtmem_header = 375,            /* pvtmem_header  */
  YYSYMBOL_earlypreamble_header = 376,     /* earlypreamble_header  */
  YYSYMBOL_in_header = 377,                /* in_header  */
  YYSYMBOL_out_header = 378,               /* out_header  */
  YYSYMBOL_tex_header = 379,               /* tex_header  */
  YYSYMBOL_iflag = 380,                    /* iflag  */
  YYSYMBOL_iflags = 381,                   /* iflags  */
  YYSYMBOL_instrs = 382,                   /* instrs  */
  YYSYMBOL_instr = 383,                    /* instr  */
  YYSYMBOL_label = 384,                    /* label  */
  YYSYMBOL_cat0_src1 = 385,                /* cat0_src1  */
  YYSYMBOL_cat0_src2 = 386,                /* cat0_src2  */
  YYSYMBOL_cat0_immed = 387,               /* cat0_immed  */
  YYSYMBOL_cat0_instr = 388,               /* cat0_instr  */
  YYSYMBOL_389_3 = 389,                    /* $@3  */
  YYSYMBOL_390_4 = 390,                    /* $@4  */
  YYSYMBOL_391_5 = 391,                    /* $@5  */
  YYSYMBOL_392_6 = 392,                    /* $@6  */
  YYSYMBOL_393_7 = 393,                    /* $@7  */
  YYSYMBOL_394_8 = 394,                    /* $@8  */
  YYSYMBOL_395_9 = 395,                    /* $@9  */
  YYSYMBOL_396_10 = 396,                   /* $@10  */
  YYSYMBOL_397_11 = 397,                   /* $@11  */
  YYSYMBOL_398_12 = 398,                   /* $@12  */
  YYSYMBOL_399_13 = 399,                   /* $@13  */
  YYSYMBOL_400_14 = 400,                   /* $@14  */
  YYSYMBOL_401_15 = 401,                   /* $@15  */
  YYSYMBOL_402_16 = 402,                   /* $@16  */
  YYSYMBOL_403_17 = 403,                   /* $@17  */
  YYSYMBOL_404_18 = 404,                   /* $@18  */
  YYSYMBOL_cat1_opc = 405,                 /* cat1_opc  */
  YYSYMBOL_cat1_src = 406,                 /* cat1_src  */
  YYSYMBOL_cat1_movmsk = 407,              /* cat1_movmsk  */
  YYSYMBOL_408_19 = 408,                   /* $@19  */
  YYSYMBOL_cat1_mova1 = 409,               /* cat1_mova1  */
  YYSYMBOL_410_20 = 410,                   /* $@20  */
  YYSYMBOL_cat1_mova = 411,                /* cat1_mova  */
  YYSYMBOL_412_21 = 412,                   /* $@21  */
  YYSYMBOL_cat1_swz = 413,                 /* cat1_swz  */
  YYSYMBOL_414_22 = 414,                   /* $@22  */
  YYSYMBOL_cat1_gat = 415,                 /* cat1_gat  */
  YYSYMBOL_416_23 = 416,                   /* $@23  */
  YYSYMBOL_cat1_sct = 417,                 /* cat1_sct  */
  YYSYMBOL_418_24 = 418,                   /* $@24  */
  YYSYMBOL_cat1_instr = 419,               /* cat1_instr  */
  YYSYMBOL_cat2_opc_1src = 420,            /* cat2_opc_1src  */
  YYSYMBOL_cat2_opc_2src_cnd = 421,        /* cat2_opc_2src_cnd  */
  YYSYMBOL_cat2_opc_2src = 422,            /* cat2_opc_2src  */
  YYSYMBOL_cond = 423,                     /* cond  */
  YYSYMBOL_cat2_instr = 424,               /* cat2_instr  */
  YYSYMBOL_cat3_dp_signedness = 425,       /* cat3_dp_signedness  */
  YYSYMBOL_cat3_dp_pack = 426,             /* cat3_dp_pack  */
  YYSYMBOL_cat3_opc = 427,                 /* cat3_opc  */
  YYSYMBOL_cat3_imm_reg_opc = 428,         /* cat3_imm_reg_opc  */
  YYSYMBOL_cat3_wmm = 429,                 /* cat3_wmm  */
  YYSYMBOL_cat3_dp = 430,                  /* cat3_dp  */
  YYSYMBOL_cat3_instr = 431,               /* cat3_instr  */
  YYSYMBOL_cat4_opc = 432,                 /* cat4_opc  */
  YYSYMBOL_cat4_instr = 433,               /* cat4_instr  */
  YYSYMBOL_cat5_opc_dsxypp = 434,          /* cat5_opc_dsxypp  */
  YYSYMBOL_cat5_opc = 435,                 /* cat5_opc  */
  YYSYMBOL_cat5_flag = 436,                /* cat5_flag  */
  YYSYMBOL_cat5_flags = 437,               /* cat5_flags  */
  YYSYMBOL_cat5_samp = 438,                /* cat5_samp  */
  YYSYMBOL_cat5_tex = 439,                 /* cat5_tex  */
  YYSYMBOL_cat5_type = 440,                /* cat5_type  */
  YYSYMBOL_cat5_a1 = 441,                  /* cat5_a1  */
  YYSYMBOL_cat5_instr = 442,               /* cat5_instr  */
  YYSYMBOL_cat6_typed = 443,               /* cat6_typed  */
  YYSYMBOL_cat6_dim = 444,                 /* cat6_dim  */
  YYSYMBOL_cat6_type = 445,                /* cat6_type  */
  YYSYMBOL_cat6_imm_offset = 446,          /* cat6_imm_offset  */
  YYSYMBOL_cat6_offset = 447,              /* cat6_offset  */
  YYSYMBOL_cat6_dst_offset = 448,          /* cat6_dst_offset  */
  YYSYMBOL_cat6_immed = 449,               /* cat6_immed  */
  YYSYMBOL_cat6_a6xx_global_address_pt3 = 450, /* cat6_a6xx_global_address_pt3  */
  YYSYMBOL_cat6_a6xx_global_address_pt2 = 451, /* cat6_a6xx_global_address_pt2  */
  YYSYMBOL_cat6_a6xx_global_address = 452, /* cat6_a6xx_global_address  */
  YYSYMBOL_cat6_load = 453,                /* cat6_load  */
  YYSYMBOL_454_25 = 454,                   /* $@25  */
  YYSYMBOL_455_26 = 455,                   /* $@26  */
  YYSYMBOL_456_27 = 456,                   /* $@27  */
  YYSYMBOL_457_28 = 457,                   /* $@28  */
  YYSYMBOL_458_29 = 458,                   /* $@29  */
  YYSYMBOL_459_30 = 459,                   /* $@30  */
  YYSYMBOL_460_31 = 460,                   /* $@31  */
  YYSYMBOL_cat6_store = 461,               /* cat6_store  */
  YYSYMBOL_462_32 = 462,                   /* $@32  */
  YYSYMBOL_463_33 = 463,                   /* $@33  */
  YYSYMBOL_464_34 = 464,                   /* $@34  */
  YYSYMBOL_465_35 = 465,                   /* $@35  */
  YYSYMBOL_466_36 = 466,                   /* $@36  */
  YYSYMBOL_cat6_loadib = 467,              /* cat6_loadib  */
  YYSYMBOL_468_37 = 468,                   /* $@37  */
  YYSYMBOL_cat6_storeib = 469,             /* cat6_storeib  */
  YYSYMBOL_470_38 = 470,                   /* $@38  */
  YYSYMBOL_cat6_prefetch = 471,            /* cat6_prefetch  */
  YYSYMBOL_472_39 = 472,                   /* $@39  */
  YYSYMBOL_cat6_atomic_opc = 473,          /* cat6_atomic_opc  */
  YYSYMBOL_cat6_a3xx_atomic_opc = 474,     /* cat6_a3xx_atomic_opc  */
  YYSYMBOL_cat6_a6xx_atomic_opc = 475,     /* cat6_a6xx_atomic_opc  */
  YYSYMBOL_cat6_a3xx_atomic_s = 476,       /* cat6_a3xx_atomic_s  */
  YYSYMBOL_cat6_a6xx_atomic_g = 477,       /* cat6_a6xx_atomic_g  */
  YYSYMBOL_cat6_atomic_l = 478,            /* cat6_atomic_l  */
  YYSYMBOL_cat6_atomic = 479,              /* cat6_atomic  */
  YYSYMBOL_cat6_ibo_opc_1src = 480,        /* cat6_ibo_opc_1src  */
  YYSYMBOL_cat6_ibo_opc_ldgb = 481,        /* cat6_ibo_opc_ldgb  */
  YYSYMBOL_cat6_ibo_opc_stgb = 482,        /* cat6_ibo_opc_stgb  */
  YYSYMBOL_cat6_ibo = 483,                 /* cat6_ibo  */
  YYSYMBOL_484_40 = 484,                   /* $@40  */
  YYSYMBOL_cat6_id_opc = 485,              /* cat6_id_opc  */
  YYSYMBOL_cat6_id = 486,                  /* cat6_id  */
  YYSYMBOL_cat6_bindless_base = 487,       /* cat6_bindless_base  */
  YYSYMBOL_cat6_bindless_mode = 488,       /* cat6_bindless_mode  */
  YYSYMBOL_cat6_reg_or_immed = 489,        /* cat6_reg_or_immed  */
  YYSYMBOL_cat6_bindless_ibo_opc_1src = 490, /* cat6_bindless_ibo_opc_1src  */
  YYSYMBOL_cat6_bindless_ibo_opc_2src = 491, /* cat6_bindless_ibo_opc_2src  */
  YYSYMBOL_cat6_bindless_ibo_opc_2src_dst = 492, /* cat6_bindless_ibo_opc_2src_dst  */
  YYSYMBOL_cat6_bindless_ibo = 493,        /* cat6_bindless_ibo  */
  YYSYMBOL_cat6_bindless_ldc_opc = 494,    /* cat6_bindless_ldc_opc  */
  YYSYMBOL_cat6_bindless_ldc_middle = 495, /* cat6_bindless_ldc_middle  */
  YYSYMBOL_cat6_bindless_ldc = 496,        /* cat6_bindless_ldc  */
  YYSYMBOL_stc_dst = 497,                  /* stc_dst  */
  YYSYMBOL_cat6_stc = 498,                 /* cat6_stc  */
  YYSYMBOL_499_41 = 499,                   /* $@41  */
  YYSYMBOL_500_42 = 500,                   /* $@42  */
  YYSYMBOL_cat6_todo = 501,                /* cat6_todo  */
  YYSYMBOL_cat6_instr = 502,               /* cat6_instr  */
  YYSYMBOL_cat7_scope = 503,               /* cat7_scope  */
  YYSYMBOL_cat7_scopes = 504,              /* cat7_scopes  */
  YYSYMBOL_cat7_barrier = 505,             /* cat7_barrier  */
  YYSYMBOL_506_43 = 506,                   /* $@43  */
  YYSYMBOL_507_44 = 507,                   /* $@44  */
  YYSYMBOL_cat7_data_cache = 508,          /* cat7_data_cache  */
  YYSYMBOL_cat7_alias_src = 509,           /* cat7_alias_src  */
  YYSYMBOL_cat7_alias_scope = 510,         /* cat7_alias_scope  */
  YYSYMBOL_cat7_instr = 511,               /* cat7_instr  */
  YYSYMBOL_512_45 = 512,                   /* $@45  */
  YYSYMBOL_raw_instr = 513,                /* raw_instr  */
  YYSYMBOL_src = 514,                      /* src  */
  YYSYMBOL_dst = 515,                      /* dst  */
  YYSYMBOL_const = 516,                    /* const  */
  YYSYMBOL_dst_reg_flag = 517,             /* dst_reg_flag  */
  YYSYMBOL_dst_reg_flags = 518,            /* dst_reg_flags  */
  YYSYMBOL_dst_reg = 519,                  /* dst_reg  */
  YYSYMBOL_src_reg_flag = 520,             /* src_reg_flag  */
  YYSYMBOL_src_reg_flags = 521,            /* src_reg_flags  */
  YYSYMBOL_src_reg = 522,                  /* src_reg  */
  YYSYMBOL_src_reg_gpr = 523,              /* src_reg_gpr  */
  YYSYMBOL_src_const = 524,                /* src_const  */
  YYSYMBOL_src_reg_or_const = 525,         /* src_reg_or_const  */
  YYSYMBOL_src_reg_or_const_or_rel = 526,  /* src_reg_or_const_or_rel  */
  YYSYMBOL_src_reg_or_const_or_rel_or_imm = 527, /* src_reg_or_const_or_rel_or_imm  */
  YYSYMBOL_src_reg_or_rel_or_imm = 528,    /* src_reg_or_rel_or_imm  */
  YYSYMBOL_offset = 529,                   /* offset  */
  YYSYMBOL_relative_gpr_src = 530,         /* relative_gpr_src  */
  YYSYMBOL_relative_gpr_dst = 531,         /* relative_gpr_dst  */
  YYSYMBOL_relative_const = 532,           /* relative_const  */
  YYSYMBOL_relative = 533,                 /* relative  */
  YYSYMBOL_immediate_cat1 = 534,           /* immediate_cat1  */
  YYSYMBOL_immediate = 535,                /* immediate  */
  YYSYMBOL_flut_immed = 536,               /* flut_immed  */
  YYSYMBOL_integer = 537,                  /* integer  */
  YYSYMBOL_float = 538,                    /* float  */
  YYSYMBOL_type = 539                      /* type  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 308 "../src/freedreno/ir3/ir3_parser.y"

#if YYDEBUG
static void print_token(FILE *file, int type, YYSTYPE value)
{
	fprintf(file, "\ntype: %d\n", type);
}

#define YYPRINT(file, type, value) print_token(file, type, value)
#endif

#line 923 "src/freedreno/ir3/ir3_parser.c"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1507

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  360
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  180
/* YYNRULES -- Number of rules.  */
#define YYNRULES  568
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1180

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   589


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   341,     2,   342,     2,     2,     2,     2,
     337,   338,     2,   348,   336,   335,   343,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   340,     2,
     349,   339,   358,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   351,     2,   352,     2,     2,     2,   344,     2,   355,
       2,     2,     2,   350,   359,     2,     2,   354,   353,     2,
       2,   345,   346,     2,   357,   347,     2,     2,     2,   356,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   709,   709,   709,   711,   712,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   727,   728,
     729,   730,   732,   738,   743,   751,   753,   753,   759,   765,
     772,   779,   788,   790,   792,   795,   797,   799,   806,   807,
     808,   809,   810,   811,   812,   813,   815,   816,   818,   819,
     821,   822,   823,   824,   825,   826,   827,   828,   829,   830,
     832,   834,   835,   837,   838,   840,   841,   843,   844,   844,
     845,   845,   846,   846,   847,   847,   848,   848,   849,   849,
     850,   850,   851,   851,   852,   852,   853,   854,   854,   855,
     856,   857,   858,   859,   860,   861,   861,   862,   863,   864,
     865,   866,   866,   867,   868,   868,   869,   870,   870,   871,
     871,   872,   873,   873,   875,   878,   882,   883,   885,   885,
     901,   901,   908,   908,   915,   915,   917,   917,   919,   919,
     922,   923,   924,   925,   926,   927,   928,   929,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   946,   947,   948,   949,   950,   951,   953,   954,
     955,   956,   957,   958,   959,   960,   961,   962,   963,   964,
     965,   966,   967,   968,   969,   970,   971,   972,   973,   974,
     975,   976,   977,   978,   979,   981,   982,   983,   984,   985,
     986,   988,   989,   990,   992,   993,   995,   996,   998,   999,
    1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,
    1010,  1011,  1012,  1013,  1015,  1016,  1017,  1018,  1019,  1021,
    1022,  1024,  1025,  1027,  1028,  1029,  1030,  1032,  1033,  1034,
    1035,  1036,  1037,  1038,  1039,  1040,  1041,  1043,  1045,  1046,
    1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,
    1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,  1067,
    1068,  1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,
    1078,  1080,  1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,
    1089,  1090,  1091,  1093,  1094,  1095,  1096,  1098,  1099,  1100,
    1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,
    1111,  1112,  1113,  1114,  1116,  1117,  1119,  1120,  1121,  1122,
    1124,  1125,  1126,  1127,  1128,  1129,  1131,  1134,  1139,  1142,
    1148,  1151,  1153,  1153,  1154,  1154,  1155,  1155,  1156,  1156,
    1157,  1157,  1158,  1158,  1158,  1162,  1162,  1163,  1163,  1164,
    1164,  1165,  1165,  1166,  1166,  1168,  1168,  1169,  1169,  1171,
    1171,  1173,  1174,  1175,  1176,  1177,  1178,  1179,  1180,  1181,
    1182,  1183,  1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,
    1193,  1194,  1195,  1197,  1198,  1199,  1200,  1201,  1202,  1203,
    1204,  1205,  1206,  1207,  1209,  1211,  1213,  1215,  1216,  1217,
    1219,  1221,  1222,  1224,  1225,  1226,  1226,  1229,  1230,  1231,
    1233,  1235,  1236,  1238,  1239,  1240,  1242,  1243,  1245,  1247,
    1248,  1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,  1257,
    1258,  1260,  1262,  1263,  1264,  1266,  1270,  1271,  1273,  1279,
    1280,  1281,  1284,  1284,  1285,  1285,  1287,  1288,  1289,  1291,
    1292,  1293,  1294,  1295,  1296,  1297,  1298,  1299,  1300,  1301,
    1302,  1304,  1305,  1306,  1307,  1309,  1310,  1312,  1312,  1313,
    1313,  1315,  1316,  1317,  1319,  1320,  1322,  1323,  1324,  1326,
    1327,  1328,  1329,  1330,  1331,  1332,  1332,  1339,  1341,  1342,
    1343,  1344,  1346,  1347,  1348,  1349,  1351,  1353,  1354,  1355,
    1356,  1357,  1359,  1360,  1363,  1364,  1366,  1367,  1368,  1369,
    1370,  1372,  1373,  1375,  1376,  1378,  1379,  1381,  1382,  1384,
    1385,  1387,  1388,  1389,  1391,  1392,  1393,  1395,  1396,  1397,
    1399,  1400,  1401,  1403,  1404,  1406,  1407,  1409,  1410,  1412,
    1413,  1419,  1420,  1421,  1422,  1423,  1424,  1425,  1427,  1428,
    1429,  1430,  1431,  1434,  1435,  1436,  1437,  1438,  1439,  1440,
    1441,  1442,  1443,  1444,  1445,  1447,  1448,  1449,  1450,  1452,
    1453,  1455,  1456,  1457,  1458,  1459,  1460,  1461,  1462
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "T_INT", "T_HEX",
  "T_FLOAT", "T_IDENTIFIER", "T_REGISTER", "T_CONSTANT", "T_A_LOCALSIZE",
  "T_A_CONST", "T_A_BUF", "T_A_INVOCATIONID", "T_A_WGID", "T_A_NUMWG",
  "T_A_BRANCHSTACK", "T_A_IN", "T_A_OUT", "T_A_TEX", "T_A_PVTMEM",
  "T_A_EARLYPREAMBLE", "T_ABSNEG", "T_NEG", "T_ABS", "T_R", "T_LAST",
  "T_HR", "T_HC", "T_EVEN", "T_POS_INFINITY", "T_NEG_INFINITY", "T_EI",
  "T_WRMASK", "T_FLUT_0_0", "T_FLUT_0_5", "T_FLUT_1_0", "T_FLUT_2_0",
  "T_FLUT_E", "T_FLUT_PI", "T_FLUT_INV_PI", "T_FLUT_INV_LOG2_E",
  "T_FLUT_LOG2_E", "T_FLUT_INV_LOG2_10", "T_FLUT_LOG2_10", "T_FLUT_4_0",
  "T_SY", "T_SS", "T_JP", "T_EQ_FLAG", "T_SAT", "T_RPT", "T_UL", "T_NOP",
  "T_OP_NOP", "T_OP_BR", "T_OP_BRAO", "T_OP_BRAA", "T_OP_BRAC",
  "T_OP_BANY", "T_OP_BALL", "T_OP_BRAX", "T_OP_JUMP", "T_OP_CALL",
  "T_OP_RET", "T_OP_KILL", "T_OP_END", "T_OP_EMIT", "T_OP_CUT",
  "T_OP_CHMASK", "T_OP_CHSH", "T_OP_FLOW_REV", "T_OP_BKT", "T_OP_STKS",
  "T_OP_STKR", "T_OP_XSET", "T_OP_XCLR", "T_OP_GETLAST", "T_OP_GETONE",
  "T_OP_DBG", "T_OP_SHPS", "T_OP_SHPE", "T_OP_PREDT", "T_OP_PREDF",
  "T_OP_PREDE", "T_OP_MOVMSK", "T_OP_MOVA1", "T_OP_MOVA", "T_OP_MOV",
  "T_OP_COV", "T_OP_SWZ", "T_OP_GAT", "T_OP_SCT", "T_OP_ADD_F",
  "T_OP_MIN_F", "T_OP_MAX_F", "T_OP_MUL_F", "T_OP_SIGN_F", "T_OP_CMPS_F",
  "T_OP_ABSNEG_F", "T_OP_CMPV_F", "T_OP_FLOOR_F", "T_OP_CEIL_F",
  "T_OP_RNDNE_F", "T_OP_RNDAZ_F", "T_OP_TRUNC_F", "T_OP_ADD_U",
  "T_OP_ADD_S", "T_OP_SUB_U", "T_OP_SUB_S", "T_OP_CMPS_U", "T_OP_CMPS_S",
  "T_OP_MIN_U", "T_OP_MIN_S", "T_OP_MAX_U", "T_OP_MAX_S", "T_OP_ABSNEG_S",
  "T_OP_AND_B", "T_OP_OR_B", "T_OP_NOT_B", "T_OP_XOR_B", "T_OP_CMPV_U",
  "T_OP_CMPV_S", "T_OP_MUL_U24", "T_OP_MUL_S24", "T_OP_MULL_U",
  "T_OP_BFREV_B", "T_OP_CLZ_S", "T_OP_CLZ_B", "T_OP_SHL_B", "T_OP_SHR_B",
  "T_OP_ASHR_B", "T_OP_BARY_F", "T_OP_FLAT_B", "T_OP_MGEN_B",
  "T_OP_GETBIT_B", "T_OP_SETRM", "T_OP_CBITS_B", "T_OP_SHB", "T_OP_MSAD",
  "T_OP_MAD_U16", "T_OP_MADSH_U16", "T_OP_MAD_S16", "T_OP_MADSH_M16",
  "T_OP_MAD_U24", "T_OP_MAD_S24", "T_OP_MAD_F16", "T_OP_MAD_F32",
  "T_OP_SEL_B16", "T_OP_SEL_B32", "T_OP_SEL_S16", "T_OP_SEL_S32",
  "T_OP_SEL_F16", "T_OP_SEL_F32", "T_OP_SAD_S16", "T_OP_SAD_S32",
  "T_OP_SHRM", "T_OP_SHLM", "T_OP_SHRG", "T_OP_SHLG", "T_OP_ANDG",
  "T_OP_DP2ACC", "T_OP_DP4ACC", "T_OP_WMM", "T_OP_WMM_ACCU", "T_OP_RCP",
  "T_OP_RSQ", "T_OP_LOG2", "T_OP_EXP2", "T_OP_SIN", "T_OP_COS",
  "T_OP_SQRT", "T_OP_HRSQ", "T_OP_HLOG2", "T_OP_HEXP2", "T_OP_ISAM",
  "T_OP_ISAML", "T_OP_ISAMM", "T_OP_SAM", "T_OP_SAMB", "T_OP_SAML",
  "T_OP_SAMGQ", "T_OP_GETLOD", "T_OP_CONV", "T_OP_CONVM", "T_OP_GETSIZE",
  "T_OP_GETBUF", "T_OP_GETPOS", "T_OP_GETINFO", "T_OP_DSX", "T_OP_DSY",
  "T_OP_GATHER4R", "T_OP_GATHER4G", "T_OP_GATHER4B", "T_OP_GATHER4A",
  "T_OP_SAMGP0", "T_OP_SAMGP1", "T_OP_SAMGP2", "T_OP_SAMGP3",
  "T_OP_DSXPP_1", "T_OP_DSYPP_1", "T_OP_RGETPOS", "T_OP_RGETINFO",
  "T_OP_BRCST_A", "T_OP_QSHUFFLE_BRCST", "T_OP_QSHUFFLE_H",
  "T_OP_QSHUFFLE_V", "T_OP_QSHUFFLE_DIAG", "T_OP_TCINV", "T_OP_LDG",
  "T_OP_LDG_A", "T_OP_LDL", "T_OP_LDP", "T_OP_STG", "T_OP_STG_A",
  "T_OP_STL", "T_OP_STP", "T_OP_LDIB", "T_OP_G2L", "T_OP_L2G",
  "T_OP_PREFETCH", "T_OP_LDLW", "T_OP_STLW", "T_OP_RESFMT", "T_OP_RESINFO",
  "T_OP_ATOMIC_ADD", "T_OP_ATOMIC_SUB", "T_OP_ATOMIC_XCHG",
  "T_OP_ATOMIC_INC", "T_OP_ATOMIC_DEC", "T_OP_ATOMIC_CMPXCHG",
  "T_OP_ATOMIC_MIN", "T_OP_ATOMIC_MAX", "T_OP_ATOMIC_AND",
  "T_OP_ATOMIC_OR", "T_OP_ATOMIC_XOR", "T_OP_RESINFO_B", "T_OP_LDIB_B",
  "T_OP_STIB_B", "T_OP_ATOMIC_B_ADD", "T_OP_ATOMIC_B_SUB",
  "T_OP_ATOMIC_B_XCHG", "T_OP_ATOMIC_B_INC", "T_OP_ATOMIC_B_DEC",
  "T_OP_ATOMIC_B_CMPXCHG", "T_OP_ATOMIC_B_MIN", "T_OP_ATOMIC_B_MAX",
  "T_OP_ATOMIC_B_AND", "T_OP_ATOMIC_B_OR", "T_OP_ATOMIC_B_XOR",
  "T_OP_ATOMIC_S_ADD", "T_OP_ATOMIC_S_SUB", "T_OP_ATOMIC_S_XCHG",
  "T_OP_ATOMIC_S_INC", "T_OP_ATOMIC_S_DEC", "T_OP_ATOMIC_S_CMPXCHG",
  "T_OP_ATOMIC_S_MIN", "T_OP_ATOMIC_S_MAX", "T_OP_ATOMIC_S_AND",
  "T_OP_ATOMIC_S_OR", "T_OP_ATOMIC_S_XOR", "T_OP_ATOMIC_G_ADD",
  "T_OP_ATOMIC_G_SUB", "T_OP_ATOMIC_G_XCHG", "T_OP_ATOMIC_G_INC",
  "T_OP_ATOMIC_G_DEC", "T_OP_ATOMIC_G_CMPXCHG", "T_OP_ATOMIC_G_MIN",
  "T_OP_ATOMIC_G_MAX", "T_OP_ATOMIC_G_AND", "T_OP_ATOMIC_G_OR",
  "T_OP_ATOMIC_G_XOR", "T_OP_LDGB", "T_OP_STGB", "T_OP_STIB", "T_OP_LDC",
  "T_OP_LDLV", "T_OP_GETSPID", "T_OP_GETWID", "T_OP_GETFIBERID",
  "T_OP_STC", "T_OP_STSC", "T_OP_BAR", "T_OP_FENCE", "T_OP_SLEEP",
  "T_OP_ICINV", "T_OP_DCCLN", "T_OP_DCINV", "T_OP_DCFLU", "T_OP_LOCK",
  "T_OP_UNLOCK", "T_OP_ALIAS", "T_RAW", "T_TYPE_F16", "T_TYPE_F32",
  "T_TYPE_U16", "T_TYPE_U32", "T_TYPE_S16", "T_TYPE_S32", "T_TYPE_U8",
  "T_TYPE_S8", "T_UNTYPED", "T_TYPED", "T_MIXED", "T_UNSIGNED", "T_LOW",
  "T_HIGH", "T_1D", "T_2D", "T_3D", "T_4D", "T_LT", "T_LE", "T_GT", "T_GE",
  "T_EQ", "T_NE", "T_S2EN", "T_SAMP", "T_TEX", "T_BASE", "T_OFFSET",
  "T_UNIFORM", "T_NONUNIFORM", "T_IMM", "T_NAN", "T_INF", "T_A0", "T_A1",
  "T_P0", "T_W", "T_CAT1_TYPE_TYPE", "T_INSTR_TYPE", "T_MOD_TEX",
  "T_MOD_MEM", "T_MOD_RT", "'-'", "','", "'('", "')'", "'='", "':'", "'!'",
  "'#'", "'.'", "'a'", "'o'", "'p'", "'s'", "'+'", "'<'", "'g'", "'['",
  "']'", "'l'", "'k'", "'c'", "'w'", "'r'", "'>'", "'h'", "$accept",
  "shader", "$@1", "headers", "header", "const_val", "localsize_header",
  "const_header", "buf_header_addr_reg", "buf_header", "$@2",
  "invocationid_header", "wgid_header", "numwg_header",
  "branchstack_header", "pvtmem_header", "earlypreamble_header",
  "in_header", "out_header", "tex_header", "iflag", "iflags", "instrs",
  "instr", "label", "cat0_src1", "cat0_src2", "cat0_immed", "cat0_instr",
  "$@3", "$@4", "$@5", "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12",
  "$@13", "$@14", "$@15", "$@16", "$@17", "$@18", "cat1_opc", "cat1_src",
  "cat1_movmsk", "$@19", "cat1_mova1", "$@20", "cat1_mova", "$@21",
  "cat1_swz", "$@22", "cat1_gat", "$@23", "cat1_sct", "$@24", "cat1_instr",
  "cat2_opc_1src", "cat2_opc_2src_cnd", "cat2_opc_2src", "cond",
  "cat2_instr", "cat3_dp_signedness", "cat3_dp_pack", "cat3_opc",
  "cat3_imm_reg_opc", "cat3_wmm", "cat3_dp", "cat3_instr", "cat4_opc",
  "cat4_instr", "cat5_opc_dsxypp", "cat5_opc", "cat5_flag", "cat5_flags",
  "cat5_samp", "cat5_tex", "cat5_type", "cat5_a1", "cat5_instr",
  "cat6_typed", "cat6_dim", "cat6_type", "cat6_imm_offset", "cat6_offset",
  "cat6_dst_offset", "cat6_immed", "cat6_a6xx_global_address_pt3",
  "cat6_a6xx_global_address_pt2", "cat6_a6xx_global_address", "cat6_load",
  "$@25", "$@26", "$@27", "$@28", "$@29", "$@30", "$@31", "cat6_store",
  "$@32", "$@33", "$@34", "$@35", "$@36", "cat6_loadib", "$@37",
  "cat6_storeib", "$@38", "cat6_prefetch", "$@39", "cat6_atomic_opc",
  "cat6_a3xx_atomic_opc", "cat6_a6xx_atomic_opc", "cat6_a3xx_atomic_s",
  "cat6_a6xx_atomic_g", "cat6_atomic_l", "cat6_atomic",
  "cat6_ibo_opc_1src", "cat6_ibo_opc_ldgb", "cat6_ibo_opc_stgb",
  "cat6_ibo", "$@40", "cat6_id_opc", "cat6_id", "cat6_bindless_base",
  "cat6_bindless_mode", "cat6_reg_or_immed", "cat6_bindless_ibo_opc_1src",
  "cat6_bindless_ibo_opc_2src", "cat6_bindless_ibo_opc_2src_dst",
  "cat6_bindless_ibo", "cat6_bindless_ldc_opc", "cat6_bindless_ldc_middle",
  "cat6_bindless_ldc", "stc_dst", "cat6_stc", "$@41", "$@42", "cat6_todo",
  "cat6_instr", "cat7_scope", "cat7_scopes", "cat7_barrier", "$@43",
  "$@44", "cat7_data_cache", "cat7_alias_src", "cat7_alias_scope",
  "cat7_instr", "$@45", "raw_instr", "src", "dst", "const", "dst_reg_flag",
  "dst_reg_flags", "dst_reg", "src_reg_flag", "src_reg_flags", "src_reg",
  "src_reg_gpr", "src_const", "src_reg_or_const",
  "src_reg_or_const_or_rel", "src_reg_or_const_or_rel_or_imm",
  "src_reg_or_rel_or_imm", "offset", "relative_gpr_src",
  "relative_gpr_dst", "relative_const", "relative", "immediate_cat1",
  "immediate", "flut_immed", "integer", "float", "type", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-856)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-4)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -856,    23,  1013,  -856,     2,  -299,     2,  -291,  -287,  -285,
       2,  -257,  -247,  -236,     2,  -856,    61,  1013,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,   158,  -151,   193,  -856,   196,    27,   201,
    -856,   209,   214,   217,  -856,  -114,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,   796,  1217,   710,  -856,  -856,
    -856,  -856,  -856,     2,  -110,  -107,  -105,  -102,   -91,   -83,
     -81,   -76,   -74,  -856,  -856,  -856,  -856,  -856,  -856,   -78,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,   -60,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,   -58,   -41,   -39,   -50,
     -45,   -38,   -37,   -17,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,    40,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,   119,   -15,   119,  -856,   119,   119,   119,    -3,
    -856,   119,  -856,    -2,    -2,  -856,  -856,  -856,  -856,  -856,
    -856,    -1,    -1,    -1,  -856,  -856,  -856,  -856,     0,    -1,
      -1,  -856,     0,  -856,    -1,    -1,    -1,  -856,     3,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,   -28,     2,   337,
    -856,  -856,  -856,  -856,  -856,   342,   343,   345,  -250,  -250,
    -250,    24,  -250,  -250,    11,    11,    11,  -250,    11,    31,
      11,    11,  -250,  -250,    32,    22,    33,    44,    50,    52,
      53,    54,     0,     0,     0,     0,     0,     0,     0,     0,
      -1,    13,     0,     0,    -1,     0,     0,     0,    43,    43,
      67,  -856,    21,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,    38,  -856,   525,    51,    60,    81,    82,   226,    83,
      92,   104,   107,  -182,    91,   108,   674,    -2,   119,   112,
    -160,   115,   115,   115,   410,   115,   115,   115,   119,   115,
     115,   115,    15,     2,   123,   124,   126,   129,   122,  -856,
     143,   136,   137,   141,  -856,  -856,   164,  -856,   142,   151,
      36,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,   119,
     119,   119,   119,   138,   139,   140,   133,   115,   144,   119,
     145,   115,   119,   146,   147,  -234,    43,  -856,  -856,  -237,
     170,   171,  -856,  -856,   155,   155,   766,  -856,  -856,  -856,
    -856,  -856,  -856,   119,   766,   293,   868,   148,  -856,  -856,
     -99,   119,   766,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,   167,   410,   119,  -856,  -856,   -35,
       0,     0,     0,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,   119,     0,     0,  -856,     0,     0,     0,   161,
     166,   177,  -856,  -856,     2,  -856,   501,   509,    24,  -856,
      11,  -249,  -249,  -856,  -856,    11,    11,    11,  -856,  -856,
      11,   119,   155,   155,   119,   119,   119,   180,   181,   183,
     184,   173,   175,   176,   178,     0,   111,   194,   208,     0,
     195,   211,   212,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,   189,  -231,  -231,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,   198,   215,  -856,  -856,  -856,     9,   222,   225,   207,
    -856,  -856,  -856,   545,    76,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,    24,   657,   910,
    -856,  -856,  -856,  -856,  -856,   224,   240,   241,   111,  -856,
     243,  -856,  -856,  -856,   245,  -856,  -856,  -856,   250,  -856,
     631,   249,   260,  -856,  -856,  -856,  -856,   202,   256,   257,
     267,   261,   263,   264,   265,   268,    24,   258,    29,   274,
     283,   290,   277,  -856,  -856,   303,   296,   297,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,   299,   301,   304,   286,   291,
     289,   298,   111,   527,   111,   111,   302,  -152,   307,   111,
     306,   309,    12,    12,   312,    24,    24,   305,   313,   331,
     344,  -856,   340,   341,   238,   346,   348,   354,   356,    56,
    -856,  -856,  -856,  -856,   373,    24,  -856,  -856,   766,   766,
     527,   527,   631,   868,  -856,  -856,   300,    24,    24,    24,
     363,    24,    24,    24,    24,    24,   371,   374,   384,  -856,
    -856,     2,    24,    24,   715,  -856,    11,    11,   119,   631,
     119,   375,   378,   387,   388,  -231,   370,    66,   376,  -146,
    -146,    24,    29,  -856,   389,  -856,   391,  -146,    24,   394,
     392,   395,  -856,   398,   403,  -856,  -856,  -856,  -856,  -231,
    -231,  -856,  -856,  -856,  -856,  -856,  -231,  -231,   413,   414,
    -856,   416,   427,  -856,   428,   429,   431,   432,  -856,  -856,
     435,  -856,   441,   440,   442,   451,   433,   119,  -856,   453,
     455,   471,   -54,   -54,    29,   479,   478,   480,   482,  -856,
    -856,   481,   486,   487,   111,   527,   111,   111,   475,   492,
      98,    29,   477,  -856,   485,   119,  -856,   495,   111,   497,
     483,    24,    24,   496,   514,    24,   494,   498,   499,   503,
    -856,  -856,  -856,   766,   293,   868,    95,   527,   544,   300,
     511,   515,   516,    29,   531,   526,   -54,   -54,   -54,   534,
     534,   534,   119,   524,  -856,     2,  -856,  -856,    24,   631,
     631,   119,  -152,   529,  -152,  -152,   547,   111,   111,  -856,
    -137,  -856,   549,   550,   552,    24,  -152,   560,   546,   548,
    -856,   631,    95,   119,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,   562,  -856,   563,  -856,   579,   119,   119,   119,
     564,   569,   570,   119,   631,   119,   601,  -856,  -856,  -856,
    -856,   573,  -856,   586,   589,   590,   591,   576,   594,   580,
     581,   111,   595,  -231,    29,   585,  -856,   111,   111,   588,
    -856,   583,   111,    95,  -856,   603,   604,   606,   868,   644,
     300,   619,   620,   624,  -856,   610,    29,   628,   629,   630,
    -856,   640,   962,   631,   631,   119,   633,    95,   645,   649,
     653,    95,   654,  -856,    24,   655,   661,   647,   663,   664,
     656,   671,    24,    24,   288,  -856,  -856,  -856,  -856,   673,
    -856,  -856,   658,   660,   111,    29,   662,    29,    29,    29,
     665,   676,  -856,   677,   680,    95,  -856,    95,    95,    95,
    -856,   685,  -231,    95,    95,    95,    95,    95,   699,    95,
    -856,  -856,  -856,  -856,  -856,   644,   686,   687,   700,   688,
     703,  -856,   705,   706,  -856,    24,   631,   631,  -856,  -856,
    -856,  -856,   694,   695,  -856,  -856,   693,  -856,  -856,   111,
    -856,  -856,  -856,    29,    29,   111,   711,   111,    29,    29,
     712,  -856,  -856,    24,   697,   713,   714,   701,   702,  -856,
     111,   716,  -856,  -856,  1006,  -856,    24,   111,   111,   719,
     720,   721,    29,   723,  -856,   722,   727,   111,   111,   111,
     728,    24,   111,   111,  -856,   731,  -856,   111,   732,  -856,
    -856,   111,  -856,  1045,   733,   734,   111,    24,  -856,  -856
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     4,     1,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    34,    46,     4,     6,     7,
       8,     9,    10,    11,    12,    16,    17,    13,    14,    15,
      19,    21,    18,     0,     0,     0,    26,     0,     0,     0,
      32,     0,     0,     0,    33,     0,    38,    39,    40,    41,
      42,    43,    44,    45,   477,    46,     0,    46,    49,    59,
      58,     5,    20,     0,     0,    25,     0,     0,     0,     0,
       0,     0,     0,    60,    47,    67,    68,    70,    72,     0,
      76,    78,    80,    82,    84,    86,    87,    89,    90,    91,
      92,    93,    94,    95,    97,    98,    99,   100,     0,   101,
     103,   104,   106,   107,   109,   111,     0,     0,     0,     0,
       0,     0,     0,     0,   158,   159,   160,   161,   142,   152,
     138,   155,   143,   144,   145,   146,   147,   162,   163,   164,
     165,   153,   154,   166,   167,   168,   169,   139,   170,   171,
     148,   172,   156,   157,   173,   174,   175,   149,   141,   140,
     176,   177,   178,   179,   180,   181,   182,   150,   151,   183,
     184,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   221,   222,   219,   220,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     238,   239,   264,   265,   266,   267,   268,   269,   270,   303,
     322,   324,   328,   326,   335,   337,   341,   339,   345,   436,
     437,   349,   330,   343,   438,   390,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   408,   421,   420,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   391,   392,   347,   425,   332,   397,   398,
     399,   432,   434,   457,   459,   471,   472,   461,   462,   463,
     473,   474,   475,    50,     0,   130,   131,   132,   133,   134,
     135,    51,     0,     0,     0,    52,     0,     0,     0,     0,
      53,     0,    54,   281,   281,    55,   439,   441,   440,   442,
     443,     0,     0,     0,   388,   389,   387,   444,     0,     0,
       0,   445,     0,   446,     0,     0,     0,   448,     0,   447,
     449,   450,    56,   469,   470,    57,    48,     0,     0,     0,
      27,    28,    29,    30,    31,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   455,   455,
       0,   482,     0,   487,   488,   489,   490,   491,   483,   484,
     485,     0,   494,   492,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   281,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    62,
       0,     0,     0,     0,   555,   557,     0,    74,     0,     0,
       0,    81,    83,    85,    88,    96,   112,   102,   105,   108,
     110,   118,   120,   122,   114,   115,   124,   126,   128,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   455,   458,   460,     0,
       0,     0,   493,   495,     0,     0,     0,   185,   186,   187,
     188,   189,   190,     0,     0,     0,     0,     0,   194,   195,
       0,     0,     0,   271,   276,   279,   277,   278,   280,   272,
     273,   274,   275,   282,     0,     0,     0,   304,   305,     0,
       0,     0,     0,   561,   562,   563,   564,   565,   566,   567,
     568,   310,     0,     0,     0,   400,     0,     0,     0,     0,
       0,     0,   316,    22,     0,    24,     0,     0,     0,    61,
       0,     0,     0,   556,   558,     0,     0,     0,    66,    65,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   454,   453,   451,   452,   456,   466,   467,
     468,     0,   520,   520,   478,   486,   496,   497,   498,   499,
     500,     0,     0,   479,   480,   481,     0,     0,     0,     0,
     136,   503,   507,   501,     0,   509,   510,   511,   116,   529,
     530,   512,   117,   531,   137,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,     0,     0,     0,
     514,   191,   516,   540,   538,     0,     0,     0,     0,   517,
       0,   518,   519,   505,     0,   506,   196,   197,     0,   237,
       0,     0,   302,   306,   307,   308,   309,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    69,    64,     0,     0,     0,    75,    77,
      79,   113,   119,   121,   123,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   520,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   559,     0,     0,     0,     0,     0,     0,     0,     0,
     502,   504,   508,   513,     0,     0,   542,   515,     0,     0,
       0,     0,     0,     0,   287,   285,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   406,
     407,     0,     0,     0,     0,    63,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   520,     0,     0,     0,   520,
     520,     0,     0,   312,     0,   311,     0,   520,     0,     0,
     430,     0,   429,     0,     0,   522,   521,   526,   525,   520,
     520,   536,   537,   560,   532,   533,   520,   520,     0,     0,
     539,     0,     0,   193,     0,     0,     0,     0,   283,   284,
     300,   301,   298,     0,     0,     0,     0,     0,   395,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    71,
      73,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   314,     0,     0,   313,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     534,   535,   541,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   401,
     401,   401,     0,     0,   428,     0,    35,    36,     0,     0,
       0,     0,   520,     0,   520,   520,     0,     0,     0,   321,
       0,   315,     0,     0,     0,     0,   520,     0,     0,     0,
     431,     0,     0,     0,   524,   528,   527,   523,   192,   223,
     224,   225,     0,   299,   296,   297,   293,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   404,   405,   403,
     426,     0,    23,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   520,     0,     0,   320,     0,     0,     0,
     350,     0,     0,     0,   333,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   393,     0,     0,     0,     0,     0,
     402,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   318,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   226,   294,   295,   286,   291,
     292,   288,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   125,     0,     0,     0,   325,     0,     0,     0,
     338,     0,   520,     0,     0,     0,     0,     0,     0,     0,
     433,   435,   476,   464,   465,     0,     0,     0,     0,     0,
       0,   422,     0,     0,   427,     0,     0,     0,   323,   329,
     327,   336,     0,     0,   342,   340,     0,   331,   344,     0,
     334,   289,   290,     0,     0,     0,     0,     0,     0,     0,
       0,   127,   129,     0,     0,     0,     0,     0,     0,   385,
       0,     0,   423,   424,     0,   319,     0,     0,     0,     0,
       0,     0,     0,     0,   317,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   386,     0,   394,     0,     0,   346,
     348,     0,   396,     0,     0,     0,     0,     0,   384,    37
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -856,  -856,  -856,  1042,  -856,    -6,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  1015,  -856,  1014,  -856,  -103,   484,  -337,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -460,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -290,  -825,  -855,
    -856,   -23,  -856,   470,   275,   571,   259,  -710,  -765,  -601,
    -856,  -856,   190,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,  -680,  -713,   -63,
    -856,  -856,  -856,  -856,  -856,  -856,  -856,   324,  -856,  -856,
    -856,  -856,  -856,  -856,  -402,  -856,  -856,  -856,  -856,  -856,
    -856,  -856,  -856,  -856,  -289,   646,  -598,  -856,   648,  -302,
    -856,  -449,  -534,  -856,  -856,  -656,  -514,  -497,  -740,  -602,
     541,  -856,  -856,  -527,    25,  -495,   404,  -380,   314,   530
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,     2,    16,    17,    34,    18,    19,   370,    20,
      65,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      55,    56,    57,    58,    59,   471,   726,   481,   313,   378,
     379,   380,   595,   382,   383,   384,   385,   386,   387,   388,
     390,   391,   392,   393,   600,   314,   650,   315,   601,   316,
     602,   317,   603,   318,   604,   319,   605,   320,   606,   321,
     322,   323,   324,   533,   325,   444,   541,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   447,   448,   860,   861,
     556,  1057,   335,   451,   560,   455,   823,   824,   892,   580,
    1006,   949,   816,   336,   402,   403,   405,   404,   412,   415,
    1051,   337,   406,   407,   409,   408,   413,   338,   410,   339,
     414,   340,   411,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   925,   352,   353,   987,   932,   798,
     354,   355,   356,   357,   358,   581,   359,   831,   360,   416,
     417,   361,   362,   516,   517,   363,   418,   419,   364,  1092,
     631,   365,   420,    60,   651,   432,   652,   433,   434,   435,
     653,   688,   655,   694,   656,   657,   680,   681,   690,   825,
     659,   436,   660,   661,   662,   682,   683,   684,   766,   571
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      36,   477,   689,   693,    40,    30,    31,    32,    44,   691,
     658,   658,   474,   475,   761,   474,   475,   518,   474,   475,
     437,   687,   439,     3,   440,   441,   442,   474,   475,   445,
     757,   758,   474,   475,    67,    68,   634,   686,    35,   474,
     475,   692,   598,   857,   449,   699,    37,   421,   482,   483,
      38,   485,    39,   487,   488,   894,   772,   367,   421,   474,
     475,   761,   899,   973,   975,   664,   422,    45,   423,   424,
     425,   426,   427,   634,   635,   654,   654,   679,   469,   724,
      41,   772,   582,   634,   635,   679,   654,   818,   658,   658,
      42,   470,   725,   679,   974,   628,   629,   630,   474,   475,
     599,    43,   641,   642,   755,   634,    46,    47,    48,    49,
      50,    51,    52,    53,   627,   796,   623,   756,   634,   624,
     538,   539,   625,   626,   854,   855,   421,   773,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   676,
     557,   558,   733,   734,   663,   663,   554,   423,   424,   425,
     426,   427,   773,   654,   654,   634,   575,   553,   474,   475,
     933,    62,   634,   635,  1056,  1060,   784,   593,   594,   636,
     637,   638,   639,   640,   641,   970,   636,   637,   638,   639,
     640,   641,   642,   755,   777,    63,   863,   864,   865,   755,
     867,   868,   869,   870,   871,  1059,   822,   607,   608,   609,
     610,    64,   891,    66,   770,   696,   697,   617,   722,    69,
     620,  1004,  1005,   983,   984,   985,    70,   893,   893,   772,
     895,    71,   663,   663,    72,   893,    73,   900,   368,   818,
     369,   685,   997,   371,   999,  1000,   372,   906,   907,   698,
    1121,   593,   594,   843,   908,   909,  1011,   373,   856,   689,
     988,   989,   862,   723,   702,   374,   691,   375,   728,   729,
     730,   972,   376,   731,   377,   381,   765,   929,   930,   931,
     710,   703,   704,   705,   706,   882,   472,   473,  1055,   478,
     479,   852,   853,   389,   484,   394,   395,   396,   692,   489,
     490,   474,   475,   397,   817,   634,   635,   774,   398,   732,
     634,   635,   735,   736,   737,   399,   400,   634,   463,   636,
     637,   638,   639,   640,   636,   637,   638,   639,   640,   641,
     642,   636,   637,   638,   639,   640,   401,   747,   438,   679,
     679,   817,   817,   762,   763,   579,   582,    33,   800,   830,
     443,   446,   450,   454,   764,   465,   462,   476,   466,   467,
     476,   468,    54,   480,  1010,   643,   644,   645,   492,   476,
     486,   491,   464,   508,   476,   771,   428,   429,   430,   493,
     520,   476,   832,   832,   494,   835,   836,   428,   429,   430,
     495,   689,   496,   497,   498,   976,   515,   521,   691,   848,
     771,   764,   643,   644,   645,   851,   524,   431,  1093,   771,
     969,  1042,   643,   644,   645,   994,   995,   582,   582,   582,
     519,   582,   582,   582,   582,   582,   968,   525,   526,   534,
     692,   971,   876,   877,   643,   644,   645,  1015,   535,   799,
     476,   647,   677,   648,   540,   948,   817,   643,   644,   645,
     536,   582,   836,   537,   542,   428,   429,   430,   582,   555,
    1028,  1090,  1091,   815,   678,   819,   820,   583,   559,   584,
     827,   588,   585,   586,   679,   654,   587,  1016,   817,   879,
     880,   589,   590,   591,   643,   644,   645,   592,   596,   614,
    1113,   643,   644,   645,   689,  1058,  1061,   597,   611,   612,
     476,   691,   646,   613,   800,   616,   632,   633,   618,  1072,
    1073,   621,   622,   700,   716,   648,   881,   720,   883,   717,
     647,   836,   648,   718,   649,   721,   738,   739,  1050,   740,
     741,   959,   960,   692,   742,   963,   743,   744,   771,   745,
     748,   751,   754,   896,   634,   635,   527,   528,   529,   530,
     531,   532,  1076,   800,   769,   787,  1080,   759,   636,   637,
     638,   639,   640,   423,   424,   425,   426,   427,   993,   749,
     778,  1058,   752,   753,   760,   924,   636,   637,   638,   639,
     640,   767,  1131,  1132,   768,   582,   779,   780,   719,   781,
    1108,   782,  1109,  1110,  1111,   799,   783,   785,  1114,  1115,
    1116,  1117,  1118,   954,  1120,   942,   786,   944,   945,   788,
     789,   950,   951,   790,   791,   817,   792,   793,   794,   956,
     801,   795,   797,   804,   643,   644,   645,   858,   859,   643,
     644,   645,   802,   476,   800,   646,   643,   644,   645,   803,
     990,   805,   806,   807,   799,   808,   811,   809,   634,   996,
     810,   812,   813,   834,   814,   821,   800,   649,   647,   828,
     648,   634,   636,   637,   638,   639,   640,   839,  1002,  1003,
     826,  1017,   829,   837,  1082,   636,   637,   638,   639,   640,
     840,   838,   582,   582,   663,  1021,  1022,  1023,   841,   842,
     846,  1027,   847,  1029,   844,   800,   845,   800,   800,   800,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   563,   564,   565,   566,   567,   568,   569,   570,
      -3,   850,  1040,   866,   872,   799,    45,   873,  1045,  1046,
     874,   878,   889,  1049,   890,  1130,   884,   561,   562,   885,
     572,   573,   574,  1074,   576,   577,   578,   799,   886,   887,
     902,   897,   898,   800,   800,   901,   905,   903,   800,   800,
     904,   910,   911,  1145,   912,    46,    47,    48,    49,    50,
      51,    52,    53,   913,   914,   915,  1154,   916,   917,   474,
     475,   918,   800,   634,   635,  1098,   799,   919,   799,   799,
     799,  1168,   615,   920,   923,   921,   619,   636,   637,   638,
     639,   640,   641,   642,   922,   875,   926,  1179,   927,   665,
     666,   667,   668,   669,   670,   671,   672,   673,   674,   675,
     676,   934,   452,   453,   928,   935,   936,   939,   937,   456,
     457,   938,   940,   941,   459,   460,   461,   946,   947,   952,
    1136,   955,   961,   958,   799,   799,  1139,   953,  1141,   799,
     799,    46,    47,    48,    49,    50,    51,    52,    53,   957,
     962,  1151,   964,   643,   644,   645,   965,   966,  1155,  1156,
     980,   967,   859,   799,   977,   978,   979,   981,  1164,  1165,
    1166,   474,   475,  1169,  1170,   634,   982,   986,  1172,   991,
     507,   998,  1174,  1001,   511,  1007,  1008,  1178,  1009,   636,
     637,   638,   639,   640,   641,   642,  1012,  1013,  1018,  1019,
    1014,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   676,   474,   475,  1020,  1024,   634,   635,  1025,
    1030,  1026,  1032,   458,  1031,  1033,  1034,  1035,  1036,   992,
    1037,  1041,  1038,  1039,  1044,  1048,   641,   642,  1047,  1052,
    1053,  1043,  1054,   665,   666,   667,   668,   669,   670,   671,
     672,   673,   674,   675,   676,  1062,  1063,   643,   644,   645,
    1064,  1065,   859,  1066,  1067,  1068,  1069,  1070,  1071,  1075,
     643,   644,   645,   499,   500,   501,   502,   503,   504,   505,
     506,  1077,   543,   509,   510,  1078,   512,   513,   514,  1079,
     544,  1083,  1081,   545,   775,   546,   547,  1084,  1085,  1086,
    1087,    54,  1099,   548,  1101,  1102,  1103,  1089,  1088,  1095,
    1097,  1096,  1153,  1106,  1100,  1105,  1107,  1104,   549,   550,
     551,   552,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,  1112,  1119,  1125,  1123,  1124,  1127,
    1126,  1128,  1129,  1133,  1134,  1135,  1146,  1140,  1144,  1147,
    1148,  1175,  1152,  1149,  1150,  1157,  1158,  1159,  1162,    61,
    1137,  1138,  1161,  1163,  1167,  1142,  1143,  1171,  1173,  1176,
      74,   366,  1122,  1177,   888,   943,   727,   833,   695,  1094,
     523,   522,   776,   849,     0,   701,     0,     0,     0,  1160,
       0,     0,   643,   644,   645,     0,     0,     0,     0,     0,
       0,   476,     0,   677,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   647,     0,   648,     0,   678,     0,     0,     0,     0,
       0,   707,   708,   709,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   711,   712,     0,   713,   714,   715,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   746,     0,     0,     0,
     750,     0,     0,     0,   643,   644,   645,     0,     0,     0,
       0,     0,     0,   476,     0,   677,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   647,     0,   648,     0,   678,     0,     0,
       0,     0,     0,     0,     0,     0,   643,   644,   645,     0,
       0,     0,     0,     0,     0,   476,     0,   677,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   647,     0,   648,     0,   678,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312
};

static const yytype_int16 yycheck[] =
{
       6,   381,   536,   537,    10,     3,     4,     5,    14,   536,
     524,   525,     3,     4,     5,     3,     4,   419,     3,     4,
     322,   535,   324,     0,   326,   327,   328,     3,     4,   331,
     632,   633,     3,     4,     7,     8,     7,   534,   337,     3,
       4,   536,     6,   783,   334,   542,   337,     7,   385,   386,
     337,   388,   337,   390,   391,   820,   654,    63,     7,     3,
       4,     5,   827,   918,   919,   525,    26,     6,    28,    29,
      30,    31,    32,     7,     8,   524,   525,   526,   328,   328,
     337,   679,   462,     7,     8,   534,   535,   743,   602,   603,
     337,   341,   341,   542,   919,   332,   333,   334,     3,     4,
     480,   337,    26,    27,   335,     7,    45,    46,    47,    48,
      49,    50,    51,    52,   516,   716,   350,   348,     7,   353,
     302,   303,   356,   357,   780,   781,     7,   654,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
     300,   301,   602,   603,   524,   525,   448,    28,    29,    30,
      31,    32,   679,   602,   603,     7,   458,   447,     3,     4,
     873,     3,     7,     8,  1019,  1020,   700,     3,     4,    21,
      22,    23,    24,    25,    26,   915,    21,    22,    23,    24,
      25,    26,    27,   335,   679,   336,   787,   788,   789,   335,
     791,   792,   793,   794,   795,  1020,   348,   499,   500,   501,
     502,     8,   348,     7,   653,   304,   305,   509,   588,     8,
     512,   348,   349,   926,   927,   928,     7,   819,   820,   817,
     821,     7,   602,   603,     7,   827,   340,   828,   338,   885,
     337,   533,   942,   338,   944,   945,   338,   839,   840,   541,
    1095,     3,     4,     5,   846,   847,   956,   338,   782,   783,
     930,   931,   786,   590,   556,   338,   783,   338,   595,   596,
     597,   917,   338,   600,   338,   343,   646,   321,   322,   323,
     572,   306,   307,   308,   309,   809,   379,   380,  1018,   382,
     383,   778,   779,   343,   387,   343,   327,   326,   783,   392,
     393,     3,     4,   343,   743,     7,     8,   677,   343,   601,
       7,     8,   604,   605,   606,   343,   343,     7,   336,    21,
      22,    23,    24,    25,    21,    22,    23,    24,    25,    26,
      27,    21,    22,    23,    24,    25,   343,   616,   343,   778,
     779,   780,   781,   324,   325,   320,   716,   335,   718,   327,
     343,   343,   343,   343,   335,     8,   343,   335,     6,     6,
     335,     6,   291,   342,   955,   326,   327,   328,   336,   335,
     329,   329,   368,   350,   335,   654,   326,   327,   328,   336,
     349,   335,   752,   753,   330,   755,   756,   326,   327,   328,
     330,   915,   330,   330,   330,   919,   343,   349,   915,   769,
     679,   335,   326,   327,   328,   775,   336,   357,  1054,   688,
     914,  1003,   326,   327,   328,   939,   940,   787,   788,   789,
     343,   791,   792,   793,   794,   795,   913,   336,   336,   336,
     915,   916,   802,   803,   326,   327,   328,   961,   336,   718,
     335,   355,   337,   357,   343,   337,   885,   326,   327,   328,
     336,   821,   822,   336,   336,   326,   327,   328,   828,   337,
     984,  1052,  1053,   742,   359,   744,   745,   463,   343,   336,
     749,   339,   338,   337,   913,   914,   337,   962,   917,   806,
     807,   328,   336,   336,   326,   327,   328,   336,   336,   346,
    1082,   326,   327,   328,  1018,  1019,  1020,   336,   350,   350,
     335,  1018,   337,   353,   874,   351,   326,   326,   353,  1033,
    1034,   355,   355,   336,   343,   357,   808,     6,   810,   343,
     355,   891,   357,   336,   359,     6,   336,   336,  1013,   336,
     336,   901,   902,  1018,   351,   905,   351,   351,   817,   351,
     336,   336,   343,   822,     7,     8,   310,   311,   312,   313,
     314,   315,  1037,   923,   337,   343,  1041,   349,    21,    22,
      23,    24,    25,    28,    29,    30,    31,    32,   938,   351,
     336,  1095,   351,   351,   349,   867,    21,    22,    23,    24,
      25,   349,  1106,  1107,   349,   955,   336,   336,   584,   336,
    1075,   336,  1077,  1078,  1079,   874,   336,   338,  1083,  1084,
    1085,  1086,  1087,   895,  1089,   884,   336,   886,   887,   343,
     343,   890,   891,   336,   343,  1054,   343,   343,   343,   898,
     336,   343,   354,   336,   326,   327,   328,   317,   318,   326,
     327,   328,   339,   335,  1004,   337,   326,   327,   328,   339,
     932,   328,   336,   336,   923,   336,   350,   336,     7,   941,
     336,   350,   353,   331,   346,   343,  1026,   359,   355,   343,
     357,     7,    21,    22,    23,    24,    25,   326,   947,   948,
     353,   963,   353,   358,  1044,    21,    22,    23,    24,    25,
     326,   358,  1052,  1053,  1054,   977,   978,   979,   338,   338,
     326,   983,   326,   985,   338,  1065,   338,  1067,  1068,  1069,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,   292,   293,   294,   295,   296,   297,   298,   299,
       0,   338,  1001,   350,   343,  1004,     6,   343,  1007,  1008,
     336,     6,   352,  1012,   348,  1105,   351,   452,   453,   351,
     455,   456,   457,  1035,   459,   460,   461,  1026,   351,   351,
     348,   352,   351,  1123,  1124,   351,   343,   352,  1128,  1129,
     352,   338,   338,  1133,   338,    45,    46,    47,    48,    49,
      50,    51,    52,   336,   336,   336,  1146,   336,   336,     3,
       4,   336,  1152,     7,     8,  1064,  1065,   336,  1067,  1068,
    1069,  1161,   507,   343,   351,   343,   511,    21,    22,    23,
      24,    25,    26,    27,   343,   801,   343,  1177,   343,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,   874,   342,   343,   343,   336,   338,   336,   338,   349,
     350,   339,   336,   336,   354,   355,   356,   352,   336,   352,
    1119,   336,   336,   350,  1123,  1124,  1125,   352,  1127,  1128,
    1129,    45,    46,    47,    48,    49,    50,    51,    52,   352,
     336,  1140,   358,   326,   327,   328,   358,   358,  1147,  1148,
     923,   358,   318,  1152,   353,   350,   350,   336,  1157,  1158,
    1159,     3,     4,  1162,  1163,     7,   350,   343,  1167,   355,
     410,   352,  1171,   336,   414,   336,   336,  1176,   336,    21,
      22,    23,    24,    25,    26,    27,   336,   351,   336,   336,
     352,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,     3,     4,   336,   352,     7,     8,   350,
     319,   351,   336,   352,   351,   336,   336,   336,   352,   935,
     336,   336,   352,   352,   349,   352,    26,    27,   350,   336,
     336,  1004,   336,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,   336,   336,   326,   327,   328,
     336,   351,   318,  1026,   336,   336,   336,   327,     6,   336,
     326,   327,   328,   402,   403,   404,   405,   406,   407,   408,
     409,   336,   308,   412,   413,   336,   415,   416,   417,   336,
     316,   336,   338,   319,   337,   321,   322,   336,   351,   336,
     336,   291,  1065,   329,  1067,  1068,  1069,   336,   352,   336,
     350,   353,     6,   336,   352,   339,   336,   352,   344,   345,
     346,   347,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,   349,   336,   336,   351,   351,   336,
     352,   336,   336,   349,   349,   352,   349,   336,   336,   336,
     336,     6,   336,   352,   352,   336,   336,   336,   336,    17,
    1123,  1124,   339,   336,   336,  1128,  1129,   336,   336,   336,
      55,    57,  1095,   339,   815,   885,   592,   753,   537,  1054,
     434,   433,   678,   769,    -1,   555,    -1,    -1,    -1,  1152,
      -1,    -1,   326,   327,   328,    -1,    -1,    -1,    -1,    -1,
      -1,   335,    -1,   337,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   355,    -1,   357,    -1,   359,    -1,    -1,    -1,    -1,
      -1,   560,   561,   562,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   573,   574,    -1,   576,   577,   578,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   615,    -1,    -1,    -1,
     619,    -1,    -1,    -1,   326,   327,   328,    -1,    -1,    -1,
      -1,    -1,    -1,   335,    -1,   337,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   355,    -1,   357,    -1,   359,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   326,   327,   328,    -1,
      -1,    -1,    -1,    -1,    -1,   335,    -1,   337,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   355,    -1,   357,    -1,   359,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   361,   362,     0,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,   363,   364,   366,   367,
     369,   371,   372,   373,   374,   375,   376,   377,   378,   379,
       3,     4,     5,   335,   365,   337,   365,   337,   337,   337,
     365,   337,   337,   337,   365,     6,    45,    46,    47,    48,
      49,    50,    51,    52,   291,   380,   381,   382,   383,   384,
     513,   363,     3,   336,     8,   370,     7,     7,     8,     8,
       7,     7,     7,   340,   381,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   388,   405,   407,   409,   411,   413,   415,
     417,   419,   420,   421,   422,   424,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   442,   453,   461,   467,   469,
     471,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   485,   486,   490,   491,   492,   493,   494,   496,
     498,   501,   502,   505,   508,   511,   383,   365,   338,   337,
     368,   338,   338,   338,   338,   338,   338,   338,   389,   390,
     391,   343,   393,   394,   395,   396,   397,   398,   399,   343,
     400,   401,   402,   403,   343,   327,   326,   343,   343,   343,
     343,   343,   454,   455,   457,   456,   462,   463,   465,   464,
     468,   472,   458,   466,   470,   459,   499,   500,   506,   507,
     512,     7,    26,    28,    29,    30,    31,    32,   326,   327,
     328,   357,   515,   517,   518,   519,   531,   519,   343,   519,
     519,   519,   519,   343,   425,   519,   343,   436,   437,   437,
     343,   443,   443,   443,   343,   445,   443,   443,   445,   443,
     443,   443,   343,   336,   365,     8,     6,     6,     6,   328,
     341,   385,   385,   385,     3,     4,   335,   537,   385,   385,
     342,   387,   387,   387,   385,   387,   329,   387,   387,   385,
     385,   329,   336,   336,   330,   330,   330,   330,   330,   445,
     445,   445,   445,   445,   445,   445,   445,   443,   350,   445,
     445,   443,   445,   445,   445,   343,   503,   504,   504,   343,
     349,   349,   518,   515,   336,   336,   336,   310,   311,   312,
     313,   314,   315,   423,   336,   336,   336,   336,   302,   303,
     343,   426,   336,   308,   316,   319,   321,   322,   329,   344,
     345,   346,   347,   437,   519,   337,   440,   300,   301,   343,
     444,   444,   444,   292,   293,   294,   295,   296,   297,   298,
     299,   539,   444,   444,   444,   519,   444,   444,   444,   320,
     449,   495,   537,   365,   336,   338,   337,   337,   339,   328,
     336,   336,   336,     3,     4,   392,   336,   336,     6,   537,
     404,   408,   410,   412,   414,   416,   418,   519,   519,   519,
     519,   350,   350,   353,   346,   444,   351,   519,   353,   444,
     519,   355,   355,   350,   353,   356,   357,   504,   332,   333,
     334,   510,   326,   326,     7,     8,    21,    22,    23,    24,
      25,    26,    27,   326,   327,   328,   337,   355,   357,   359,
     406,   514,   516,   520,   521,   522,   524,   525,   526,   530,
     532,   533,   534,   537,   406,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,   337,   359,   521,
     526,   527,   535,   536,   537,   519,   527,   526,   521,   522,
     528,   533,   535,   522,   523,   530,   304,   305,   519,   527,
     336,   539,   519,   306,   307,   308,   309,   445,   445,   445,
     519,   445,   445,   445,   445,   445,   343,   343,   336,   365,
       6,     6,   537,   387,   328,   341,   386,   386,   387,   387,
     387,   387,   519,   406,   406,   519,   519,   519,   336,   336,
     336,   336,   351,   351,   351,   351,   445,   514,   336,   351,
     445,   336,   351,   351,   343,   335,   348,   529,   529,   349,
     349,     5,   324,   325,   335,   537,   538,   349,   349,   337,
     521,   514,   516,   533,   537,   337,   536,   535,   336,   336,
     336,   336,   336,   336,   522,   338,   336,   343,   343,   343,
     336,   343,   343,   343,   343,   343,   449,   354,   489,   514,
     537,   336,   339,   339,   336,   328,   336,   336,   336,   336,
     336,   350,   350,   353,   346,   514,   452,   521,   525,   514,
     514,   343,   348,   446,   447,   529,   353,   514,   343,   353,
     327,   497,   537,   497,   331,   537,   537,   358,   358,   326,
     326,   338,   338,     5,   338,   338,   326,   326,   537,   538,
     338,   537,   527,   527,   525,   525,   522,   528,   317,   318,
     438,   439,   522,   449,   449,   449,   350,   449,   449,   449,
     449,   449,   343,   343,   336,   365,   537,   537,     6,   387,
     387,   519,   522,   519,   351,   351,   351,   351,   446,   352,
     348,   348,   448,   529,   448,   449,   514,   352,   351,   448,
     449,   351,   348,   352,   352,   343,   529,   529,   529,   529,
     338,   338,   338,   336,   336,   336,   336,   336,   336,   336,
     343,   343,   343,   351,   519,   484,   343,   343,   343,   321,
     322,   323,   488,   488,   489,   336,   338,   338,   339,   336,
     336,   336,   514,   452,   514,   514,   352,   336,   337,   451,
     514,   514,   352,   352,   519,   336,   514,   352,   350,   537,
     537,   336,   336,   537,   358,   358,   358,   358,   527,   526,
     528,   535,   525,   439,   438,   439,   522,   353,   350,   350,
     489,   336,   350,   488,   488,   488,   343,   487,   487,   487,
     519,   355,   365,   537,   522,   522,   519,   447,   352,   447,
     447,   336,   514,   514,   348,   349,   450,   336,   336,   336,
     449,   447,   336,   351,   352,   522,   535,   519,   336,   336,
     336,   519,   519,   519,   352,   350,   351,   519,   522,   519,
     319,   351,   336,   336,   336,   336,   352,   336,   352,   352,
     514,   336,   529,   489,   349,   514,   514,   350,   352,   514,
     535,   460,   336,   336,   336,   528,   439,   441,   522,   438,
     439,   522,   336,   336,   336,   351,   489,   336,   336,   336,
     327,     6,   522,   522,   519,   336,   535,   336,   336,   336,
     535,   338,   537,   336,   336,   351,   336,   336,   352,   336,
     449,   449,   509,   525,   534,   336,   353,   350,   514,   489,
     352,   489,   489,   489,   352,   339,   336,   336,   535,   535,
     535,   535,   349,   529,   535,   535,   535,   535,   535,   336,
     535,   439,   441,   351,   351,   336,   352,   336,   336,   336,
     537,   522,   522,   349,   349,   352,   514,   489,   489,   514,
     336,   514,   489,   489,   336,   537,   349,   336,   336,   352,
     352,   514,   336,     6,   537,   514,   514,   336,   336,   336,
     489,   339,   336,   336,   514,   514,   514,   336,   537,   514,
     514,   336,   514,   336,   514,     6,   336,   339,   514,   537
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   360,   362,   361,   363,   363,   364,   364,   364,   364,
     364,   364,   364,   364,   364,   364,   364,   364,   365,   365,
     365,   365,   366,   367,   368,   368,   370,   369,   371,   372,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   380,
     380,   380,   380,   380,   380,   380,   381,   381,   382,   382,
     383,   383,   383,   383,   383,   383,   383,   383,   383,   383,
     384,   385,   385,   386,   386,   387,   387,   388,   389,   388,
     390,   388,   391,   388,   392,   388,   393,   388,   394,   388,
     395,   388,   396,   388,   397,   388,   388,   398,   388,   388,
     388,   388,   388,   388,   388,   399,   388,   388,   388,   388,
     388,   400,   388,   388,   401,   388,   388,   402,   388,   403,
     388,   388,   404,   388,   405,   405,   406,   406,   408,   407,
     410,   409,   412,   411,   414,   413,   416,   415,   418,   417,
     419,   419,   419,   419,   419,   419,   419,   419,   420,   420,
     420,   420,   420,   420,   420,   420,   420,   420,   420,   420,
     420,   420,   421,   421,   421,   421,   421,   421,   422,   422,
     422,   422,   422,   422,   422,   422,   422,   422,   422,   422,
     422,   422,   422,   422,   422,   422,   422,   422,   422,   422,
     422,   422,   422,   422,   422,   423,   423,   423,   423,   423,
     423,   424,   424,   424,   425,   425,   426,   426,   427,   427,
     427,   427,   427,   427,   427,   427,   427,   427,   427,   427,
     427,   427,   427,   427,   428,   428,   428,   428,   428,   429,
     429,   430,   430,   431,   431,   431,   431,   432,   432,   432,
     432,   432,   432,   432,   432,   432,   432,   433,   434,   434,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   436,   436,   436,   436,   436,   436,   436,   436,   436,
     436,   437,   437,   438,   439,   440,   441,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   443,   443,   444,   444,   444,   444,
     445,   446,   447,   447,   448,   448,   449,   450,   450,   451,
     451,   452,   454,   453,   455,   453,   456,   453,   457,   453,
     458,   453,   459,   460,   453,   462,   461,   463,   461,   464,
     461,   465,   461,   466,   461,   468,   467,   470,   469,   472,
     471,   473,   473,   473,   473,   473,   473,   473,   473,   473,
     473,   473,   474,   474,   474,   474,   474,   474,   474,   474,
     474,   474,   474,   475,   475,   475,   475,   475,   475,   475,
     475,   475,   475,   475,   476,   477,   478,   479,   479,   479,
     480,   481,   482,   483,   483,   484,   483,   485,   485,   485,
     486,   487,   487,   488,   488,   488,   489,   489,   490,   491,
     491,   491,   491,   491,   491,   491,   491,   491,   491,   491,
     491,   492,   493,   493,   493,   494,   495,   495,   496,   497,
     497,   497,   499,   498,   500,   498,   501,   501,   501,   502,
     502,   502,   502,   502,   502,   502,   502,   502,   502,   502,
     502,   503,   503,   503,   503,   504,   504,   506,   505,   507,
     505,   508,   508,   508,   509,   509,   510,   510,   510,   511,
     511,   511,   511,   511,   511,   512,   511,   513,   514,   514,
     514,   514,   515,   515,   515,   515,   516,   517,   517,   517,
     517,   517,   518,   518,   519,   519,   520,   520,   520,   520,
     520,   521,   521,   522,   522,   523,   523,   524,   524,   525,
     525,   526,   526,   526,   527,   527,   527,   528,   528,   528,
     529,   529,   529,   530,   530,   531,   531,   532,   532,   533,
     533,   534,   534,   534,   534,   534,   534,   534,   535,   535,
     535,   535,   535,   536,   536,   536,   536,   536,   536,   536,
     536,   536,   536,   536,   536,   537,   537,   537,   537,   538,
     538,   539,   539,   539,   539,   539,   539,   539,   539
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     3,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     6,    11,     3,     0,     0,     4,     4,     4,
       4,     4,     2,     2,     1,    10,    10,    23,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     2,     2,     1,
       2,     2,     2,     2,     2,     2,     2,     2,     1,     1,
       2,     2,     1,     2,     1,     2,     2,     1,     0,     5,
       0,     7,     0,     7,     0,     5,     0,     5,     0,     5,
       0,     3,     0,     3,     0,     3,     1,     0,     3,     1,
       1,     1,     1,     1,     1,     0,     3,     1,     1,     1,
       1,     0,     3,     1,     0,     3,     1,     0,     3,     0,
       3,     1,     0,     5,     3,     3,     1,     1,     0,     5,
       0,     5,     0,     5,     0,    11,     0,    13,     0,    13,
       1,     1,     1,     1,     1,     1,     4,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     8,     6,     2,     2,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     8,     8,     8,    10,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     0,     2,     1,     1,     3,     1,     5,    10,    12,
      12,    10,    10,     8,    10,    10,     8,     8,     6,     8,
       6,     6,     4,     1,     2,     2,     2,     2,     2,     2,
       2,     1,     1,     2,     1,     2,     1,     7,     2,     7,
       2,     3,     0,    12,     0,    11,     0,    12,     0,    12,
       0,    12,     0,     0,    12,     0,    12,     0,    11,     0,
      12,     0,    12,     0,    12,     0,    17,     0,    17,     0,
       9,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,    20,    13,    16,     1,     1,     1,
       1,     1,     1,     9,    16,     0,    17,     1,     1,     1,
       3,     0,     2,     2,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,    11,    13,    13,     1,     6,     9,     7,     1,
       1,     3,     0,    11,     0,    11,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     0,     2,     0,     3,     0,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,    11,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     2,     1,     1,     1,     1,
       1,     1,     2,     1,     2,     1,     1,     1,     2,     1,
       1,     1,     1,     2,     1,     2,     1,     1,     1,     1,
       0,     2,     2,     5,     5,     5,     5,     5,     5,     1,
       1,     1,     3,     3,     4,     4,     3,     3,     1,     3,
       1,     4,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     1,     2,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* $@1: %empty  */
#line 709 "../src/freedreno/ir3/ir3_parser.y"
                   { new_shader(); }
#line 3132 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 18: /* const_val: T_FLOAT  */
#line 727 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = fui((yyvsp[0].flt)); }
#line 3138 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 19: /* const_val: T_INT  */
#line 728 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = (yyvsp[0].num);      }
#line 3144 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 20: /* const_val: '-' T_INT  */
#line 729 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = -(yyvsp[0].num);     }
#line 3150 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 21: /* const_val: T_HEX  */
#line 730 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = (yyvsp[0].unum);      }
#line 3156 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 22: /* localsize_header: T_A_LOCALSIZE const_val ',' const_val ',' const_val  */
#line 732 "../src/freedreno/ir3/ir3_parser.y"
                                                                       {
                       variant->local_size[0] = (yyvsp[-4].unum);
                       variant->local_size[1] = (yyvsp[-2].unum);
                       variant->local_size[2] = (yyvsp[0].unum);
}
#line 3166 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 23: /* const_header: T_A_CONST '(' T_CONSTANT ')' const_val ',' const_val ',' const_val ',' const_val  */
#line 738 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                    {
                       add_const((yyvsp[-8].num), (yyvsp[-6].unum), (yyvsp[-4].unum), (yyvsp[-2].unum), (yyvsp[0].unum));
}
#line 3174 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 24: /* buf_header_addr_reg: '(' T_CONSTANT ')'  */
#line 743 "../src/freedreno/ir3/ir3_parser.y"
                                      {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;

                       info->buf_addr_regs[info->num_bufs - 1] = reg;
                       /* reserve space in immediates for the actual value to be plugged in later: */
                       add_const((yyvsp[-1].num), 0, 0, 0, 0);
}
#line 3187 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 26: /* $@2: %empty  */
#line 753 "../src/freedreno/ir3/ir3_parser.y"
                                     {
                       int idx = info->num_bufs++;
                       assert(idx < MAX_BUFS);
                       info->buf_sizes[idx] = (yyvsp[0].unum);
}
#line 3197 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 28: /* invocationid_header: T_A_INVOCATIONID '(' T_REGISTER ')'  */
#line 759 "../src/freedreno/ir3/ir3_parser.y"
                                                         {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       add_sysval(reg, 0x7, SYSTEM_VALUE_LOCAL_INVOCATION_ID);
}
#line 3207 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 29: /* wgid_header: T_A_WGID '(' T_REGISTER ')'  */
#line 765 "../src/freedreno/ir3/ir3_parser.y"
                                               {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       assert(variant->compiler->gen >= 5);
                       assert(reg >= regid(48, 0)); /* must be a high reg */
                       add_sysval(reg, 0x7, SYSTEM_VALUE_WORKGROUP_ID);
}
#line 3219 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 30: /* wgid_header: T_A_WGID '(' T_CONSTANT ')'  */
#line 772 "../src/freedreno/ir3/ir3_parser.y"
                                               {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       assert(variant->compiler->gen < 5);
                       info->wgid = reg;
}
#line 3230 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 31: /* numwg_header: T_A_NUMWG '(' T_CONSTANT ')'  */
#line 779 "../src/freedreno/ir3/ir3_parser.y"
                                                {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       info->numwg = reg;
                       /* reserve space in immediates for the actual value to be plugged in later: */
                       if (variant->compiler->gen >= 5)
                          add_const((yyvsp[-1].num), 0, 0, 0, 0);
}
#line 3243 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 32: /* branchstack_header: T_A_BRANCHSTACK const_val  */
#line 788 "../src/freedreno/ir3/ir3_parser.y"
                                              { variant->branchstack = (yyvsp[0].unum); }
#line 3249 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 33: /* pvtmem_header: T_A_PVTMEM const_val  */
#line 790 "../src/freedreno/ir3/ir3_parser.y"
                                    { variant->pvtmem_size = (yyvsp[0].unum); }
#line 3255 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 34: /* earlypreamble_header: T_A_EARLYPREAMBLE  */
#line 792 "../src/freedreno/ir3/ir3_parser.y"
                                        { info->early_preamble = 1; }
#line 3261 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 35: /* in_header: T_A_IN '(' T_REGISTER ')' T_IDENTIFIER '(' T_IDENTIFIER '=' integer ')'  */
#line 795 "../src/freedreno/ir3/ir3_parser.y"
                                                                                           { }
#line 3267 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 36: /* out_header: T_A_OUT '(' T_REGISTER ')' T_IDENTIFIER '(' T_IDENTIFIER '=' integer ')'  */
#line 797 "../src/freedreno/ir3/ir3_parser.y"
                                                                                            { }
#line 3273 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 37: /* tex_header: T_A_TEX '(' T_REGISTER ')' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer  */
#line 804 "../src/freedreno/ir3/ir3_parser.y"
                                                              { }
#line 3279 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 38: /* iflag: T_SY  */
#line 806 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SY; }
#line 3285 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 39: /* iflag: T_SS  */
#line 807 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SS; }
#line 3291 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 40: /* iflag: T_JP  */
#line 808 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_JP; }
#line 3297 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 41: /* iflag: T_EQ_FLAG  */
#line 809 "../src/freedreno/ir3/ir3_parser.y"
                             { iflags.flags |= IR3_INSTR_EQ; }
#line 3303 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 42: /* iflag: T_SAT  */
#line 810 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SAT; }
#line 3309 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 43: /* iflag: T_RPT  */
#line 811 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.repeat = (yyvsp[0].num); }
#line 3315 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 44: /* iflag: T_UL  */
#line 812 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_UL; }
#line 3321 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 45: /* iflag: T_NOP  */
#line 813 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.nop = (yyvsp[0].tok); }
#line 3327 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 55: /* instr: iflags cat5_instr  */
#line 826 "../src/freedreno/ir3/ir3_parser.y"
                                     { fixup_cat5_s2en(); }
#line 3333 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 60: /* label: T_IDENTIFIER ':'  */
#line 832 "../src/freedreno/ir3/ir3_parser.y"
                                    { new_label((yyvsp[-1].str)); }
#line 3339 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 61: /* cat0_src1: '!' T_P0  */
#line 834 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.inv1 = true; instr->cat0.comp1 = (yyvsp[0].num) >> 1; }
#line 3345 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 62: /* cat0_src1: T_P0  */
#line 835 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.comp1 = (yyvsp[0].num) >> 1; }
#line 3351 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 63: /* cat0_src2: '!' T_P0  */
#line 837 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.inv2 = true; instr->cat0.comp2 = (yyvsp[0].num) >> 1; }
#line 3357 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 64: /* cat0_src2: T_P0  */
#line 838 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.comp2 = (yyvsp[0].num) >> 1; }
#line 3363 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 65: /* cat0_immed: '#' integer  */
#line 840 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.immed = (yyvsp[0].num); }
#line 3369 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 66: /* cat0_immed: '#' T_IDENTIFIER  */
#line 841 "../src/freedreno/ir3/ir3_parser.y"
                                    { ralloc_steal(instr, (void *)(yyvsp[0].str)); instr->cat0.target_label = (yyvsp[0].str); }
#line 3375 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 67: /* cat0_instr: T_OP_NOP  */
#line 843 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_NOP); }
#line 3381 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 68: /* $@3: %empty  */
#line 844 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_PLAIN; }
#line 3387 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 70: /* $@4: %empty  */
#line 845 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_OR;    }
#line 3393 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 72: /* $@5: %empty  */
#line 846 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_AND;    }
#line 3399 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 74: /* $@6: %empty  */
#line 847 "../src/freedreno/ir3/ir3_parser.y"
                                         { new_instr(OPC_B)->cat0.brtype = BRANCH_CONST; instr->cat0.idx = (yyvsp[0].num); }
#line 3405 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 76: /* $@7: %empty  */
#line 848 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_ANY; }
#line 3411 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 78: /* $@8: %empty  */
#line 849 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_ALL; }
#line 3417 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 80: /* $@9: %empty  */
#line 850 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_X; }
#line 3423 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 82: /* $@10: %empty  */
#line 851 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_JUMP); }
#line 3429 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 84: /* $@11: %empty  */
#line 852 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CALL); }
#line 3435 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 86: /* cat0_instr: T_OP_RET  */
#line 853 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_RET); }
#line 3441 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 87: /* $@12: %empty  */
#line 854 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_KILL); }
#line 3447 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 89: /* cat0_instr: T_OP_END  */
#line 855 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_END); }
#line 3453 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 90: /* cat0_instr: T_OP_EMIT  */
#line 856 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_EMIT); }
#line 3459 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 91: /* cat0_instr: T_OP_CUT  */
#line 857 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CUT); }
#line 3465 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 92: /* cat0_instr: T_OP_CHMASK  */
#line 858 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CHMASK); }
#line 3471 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 93: /* cat0_instr: T_OP_CHSH  */
#line 859 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CHSH); }
#line 3477 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 94: /* cat0_instr: T_OP_FLOW_REV  */
#line 860 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_FLOW_REV); }
#line 3483 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 95: /* $@13: %empty  */
#line 861 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BKT); }
#line 3489 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 97: /* cat0_instr: T_OP_STKS  */
#line 862 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_STKS); }
#line 3495 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 98: /* cat0_instr: T_OP_STKR  */
#line 863 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_STKR); }
#line 3501 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 99: /* cat0_instr: T_OP_XSET  */
#line 864 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_XSET); }
#line 3507 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 100: /* cat0_instr: T_OP_XCLR  */
#line 865 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_XCLR); }
#line 3513 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 101: /* $@14: %empty  */
#line 866 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_GETONE); }
#line 3519 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 103: /* cat0_instr: T_OP_DBG  */
#line 867 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_DBG); }
#line 3525 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 104: /* $@15: %empty  */
#line 868 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_SHPS); }
#line 3531 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 106: /* cat0_instr: T_OP_SHPE  */
#line 869 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_SHPE); }
#line 3537 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 107: /* $@16: %empty  */
#line 870 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDT); }
#line 3543 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 109: /* $@17: %empty  */
#line 871 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDF); }
#line 3549 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 111: /* cat0_instr: T_OP_PREDE  */
#line 872 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDE); }
#line 3555 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 112: /* $@18: %empty  */
#line 873 "../src/freedreno/ir3/ir3_parser.y"
                                        { new_instr(OPC_GETLAST); }
#line 3561 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 114: /* cat1_opc: T_OP_MOV '.' T_CAT1_TYPE_TYPE  */
#line 875 "../src/freedreno/ir3/ir3_parser.y"
                                                 {
                       parse_type_type(new_instr(OPC_MOV), (yyvsp[0].str));
}
#line 3569 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 115: /* cat1_opc: T_OP_COV '.' T_CAT1_TYPE_TYPE  */
#line 878 "../src/freedreno/ir3/ir3_parser.y"
                                                 {
                       parse_type_type(new_instr(OPC_MOV), (yyvsp[0].str));
}
#line 3577 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 118: /* $@19: %empty  */
#line 885 "../src/freedreno/ir3/ir3_parser.y"
                                       {
                       new_instr(OPC_MOVMSK);
                       instr->cat1.src_type = TYPE_U32;
                       instr->cat1.dst_type = TYPE_U32;
                   }
#line 3587 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 119: /* cat1_movmsk: T_OP_MOVMSK '.' T_W $@19 dst_reg  */
#line 889 "../src/freedreno/ir3/ir3_parser.y"
                             {
                       if (((yyvsp[-2].num) % 32) != 0)
                          yyerror("w# must be multiple of 32");
                       if ((yyvsp[-2].num) < 32)
                          yyerror("w# must be at least 32");

                       int num = (yyvsp[-2].num) / 32;

                       instr->repeat = num - 1;
                       instr->dsts[0]->wrmask = (1 << num) - 1;
                   }
#line 3603 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 120: /* $@20: %empty  */
#line 901 "../src/freedreno/ir3/ir3_parser.y"
                                       {
                       new_instr(OPC_MOV);
                       instr->cat1.src_type = TYPE_U16;
                       instr->cat1.dst_type = TYPE_U16;
                       new_dst((61 << 3) + 2, IR3_REG_HALF);
                   }
#line 3614 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 122: /* $@21: %empty  */
#line 908 "../src/freedreno/ir3/ir3_parser.y"
                                      {
                       new_instr(OPC_MOV);
                       instr->cat1.src_type = TYPE_S16;
                       instr->cat1.dst_type = TYPE_S16;
                       new_dst((61 << 3), IR3_REG_HALF);
                   }
#line 3625 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 124: /* $@22: %empty  */
#line 915 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_SWZ), (yyvsp[0].str)); }
#line 3631 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 126: /* $@23: %empty  */
#line 917 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_GAT), (yyvsp[0].str)); }
#line 3637 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 128: /* $@24: %empty  */
#line 919 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_SCT), (yyvsp[0].str)); }
#line 3643 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 138: /* cat2_opc_1src: T_OP_ABSNEG_F  */
#line 931 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ABSNEG_F); }
#line 3649 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 139: /* cat2_opc_1src: T_OP_ABSNEG_S  */
#line 932 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ABSNEG_S); }
#line 3655 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 140: /* cat2_opc_1src: T_OP_CLZ_B  */
#line 933 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CLZ_B); }
#line 3661 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 141: /* cat2_opc_1src: T_OP_CLZ_S  */
#line 934 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CLZ_S); }
#line 3667 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 142: /* cat2_opc_1src: T_OP_SIGN_F  */
#line 935 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SIGN_F); }
#line 3673 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 143: /* cat2_opc_1src: T_OP_FLOOR_F  */
#line 936 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_FLOOR_F); }
#line 3679 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 144: /* cat2_opc_1src: T_OP_CEIL_F  */
#line 937 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CEIL_F); }
#line 3685 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 145: /* cat2_opc_1src: T_OP_RNDNE_F  */
#line 938 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RNDNE_F); }
#line 3691 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 146: /* cat2_opc_1src: T_OP_RNDAZ_F  */
#line 939 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RNDAZ_F); }
#line 3697 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 147: /* cat2_opc_1src: T_OP_TRUNC_F  */
#line 940 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_TRUNC_F); }
#line 3703 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 148: /* cat2_opc_1src: T_OP_NOT_B  */
#line 941 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_NOT_B); }
#line 3709 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 149: /* cat2_opc_1src: T_OP_BFREV_B  */
#line 942 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BFREV_B); }
#line 3715 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 150: /* cat2_opc_1src: T_OP_SETRM  */
#line 943 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SETRM); }
#line 3721 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 151: /* cat2_opc_1src: T_OP_CBITS_B  */
#line 944 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CBITS_B); }
#line 3727 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 152: /* cat2_opc_2src_cnd: T_OP_CMPS_F  */
#line 946 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_F); }
#line 3733 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 153: /* cat2_opc_2src_cnd: T_OP_CMPS_U  */
#line 947 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_U); }
#line 3739 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 154: /* cat2_opc_2src_cnd: T_OP_CMPS_S  */
#line 948 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_S); }
#line 3745 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 155: /* cat2_opc_2src_cnd: T_OP_CMPV_F  */
#line 949 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_F); }
#line 3751 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 156: /* cat2_opc_2src_cnd: T_OP_CMPV_U  */
#line 950 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_U); }
#line 3757 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 157: /* cat2_opc_2src_cnd: T_OP_CMPV_S  */
#line 951 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_S); }
#line 3763 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 158: /* cat2_opc_2src: T_OP_ADD_F  */
#line 953 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_F); }
#line 3769 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 159: /* cat2_opc_2src: T_OP_MIN_F  */
#line 954 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_F); }
#line 3775 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 160: /* cat2_opc_2src: T_OP_MAX_F  */
#line 955 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_F); }
#line 3781 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 161: /* cat2_opc_2src: T_OP_MUL_F  */
#line 956 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_F); }
#line 3787 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 162: /* cat2_opc_2src: T_OP_ADD_U  */
#line 957 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_U); }
#line 3793 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 163: /* cat2_opc_2src: T_OP_ADD_S  */
#line 958 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_S); }
#line 3799 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 164: /* cat2_opc_2src: T_OP_SUB_U  */
#line 959 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SUB_U); }
#line 3805 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 165: /* cat2_opc_2src: T_OP_SUB_S  */
#line 960 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SUB_S); }
#line 3811 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 166: /* cat2_opc_2src: T_OP_MIN_U  */
#line 961 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_U); }
#line 3817 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 167: /* cat2_opc_2src: T_OP_MIN_S  */
#line 962 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_S); }
#line 3823 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 168: /* cat2_opc_2src: T_OP_MAX_U  */
#line 963 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_U); }
#line 3829 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 169: /* cat2_opc_2src: T_OP_MAX_S  */
#line 964 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_S); }
#line 3835 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 170: /* cat2_opc_2src: T_OP_AND_B  */
#line 965 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_AND_B); }
#line 3841 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 171: /* cat2_opc_2src: T_OP_OR_B  */
#line 966 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_OR_B); }
#line 3847 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 172: /* cat2_opc_2src: T_OP_XOR_B  */
#line 967 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_XOR_B); }
#line 3853 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 173: /* cat2_opc_2src: T_OP_MUL_U24  */
#line 968 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_U24); }
#line 3859 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 174: /* cat2_opc_2src: T_OP_MUL_S24  */
#line 969 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_S24); }
#line 3865 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 175: /* cat2_opc_2src: T_OP_MULL_U  */
#line 970 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MULL_U); }
#line 3871 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 176: /* cat2_opc_2src: T_OP_SHL_B  */
#line 971 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHL_B); }
#line 3877 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 177: /* cat2_opc_2src: T_OP_SHR_B  */
#line 972 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHR_B); }
#line 3883 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 178: /* cat2_opc_2src: T_OP_ASHR_B  */
#line 973 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ASHR_B); }
#line 3889 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 179: /* cat2_opc_2src: T_OP_BARY_F  */
#line 974 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BARY_F); }
#line 3895 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 180: /* cat2_opc_2src: T_OP_FLAT_B  */
#line 975 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_FLAT_B); }
#line 3901 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 181: /* cat2_opc_2src: T_OP_MGEN_B  */
#line 976 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MGEN_B); }
#line 3907 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 182: /* cat2_opc_2src: T_OP_GETBIT_B  */
#line 977 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETBIT_B); }
#line 3913 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 183: /* cat2_opc_2src: T_OP_SHB  */
#line 978 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHB); }
#line 3919 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 184: /* cat2_opc_2src: T_OP_MSAD  */
#line 979 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MSAD); }
#line 3925 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 185: /* cond: T_LT  */
#line 981 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_LT; }
#line 3931 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 186: /* cond: T_LE  */
#line 982 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_LE; }
#line 3937 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 187: /* cond: T_GT  */
#line 983 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_GT; }
#line 3943 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 188: /* cond: T_GE  */
#line 984 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_GE; }
#line 3949 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 189: /* cond: T_EQ  */
#line 985 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_EQ; }
#line 3955 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 190: /* cond: T_NE  */
#line 986 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_NE; }
#line 3961 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 194: /* cat3_dp_signedness: '.' T_MIXED  */
#line 992 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.signedness = IR3_SRC_MIXED; }
#line 3967 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 195: /* cat3_dp_signedness: '.' T_UNSIGNED  */
#line 993 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.signedness = IR3_SRC_UNSIGNED; }
#line 3973 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 196: /* cat3_dp_pack: '.' T_LOW  */
#line 995 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.packed = IR3_SRC_PACKED_LOW; }
#line 3979 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 197: /* cat3_dp_pack: '.' T_HIGH  */
#line 996 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.packed = IR3_SRC_PACKED_HIGH; }
#line 3985 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 198: /* cat3_opc: T_OP_MAD_U16  */
#line 998 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_U16); }
#line 3991 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 199: /* cat3_opc: T_OP_MADSH_U16  */
#line 999 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MADSH_U16); }
#line 3997 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 200: /* cat3_opc: T_OP_MAD_S16  */
#line 1000 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_S16); }
#line 4003 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 201: /* cat3_opc: T_OP_MADSH_M16  */
#line 1001 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MADSH_M16); }
#line 4009 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 202: /* cat3_opc: T_OP_MAD_U24  */
#line 1002 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_U24); }
#line 4015 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 203: /* cat3_opc: T_OP_MAD_S24  */
#line 1003 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_S24); }
#line 4021 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 204: /* cat3_opc: T_OP_MAD_F16  */
#line 1004 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_F16); }
#line 4027 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 205: /* cat3_opc: T_OP_MAD_F32  */
#line 1005 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_F32); }
#line 4033 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 206: /* cat3_opc: T_OP_SEL_B16  */
#line 1006 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_B16); }
#line 4039 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 207: /* cat3_opc: T_OP_SEL_B32  */
#line 1007 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_B32); }
#line 4045 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 208: /* cat3_opc: T_OP_SEL_S16  */
#line 1008 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_S16); }
#line 4051 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 209: /* cat3_opc: T_OP_SEL_S32  */
#line 1009 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_S32); }
#line 4057 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 210: /* cat3_opc: T_OP_SEL_F16  */
#line 1010 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_F16); }
#line 4063 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 211: /* cat3_opc: T_OP_SEL_F32  */
#line 1011 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_F32); }
#line 4069 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 212: /* cat3_opc: T_OP_SAD_S16  */
#line 1012 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAD_S16); }
#line 4075 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 213: /* cat3_opc: T_OP_SAD_S32  */
#line 1013 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAD_S32); }
#line 4081 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 214: /* cat3_imm_reg_opc: T_OP_SHRM  */
#line 1015 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHRM); }
#line 4087 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 215: /* cat3_imm_reg_opc: T_OP_SHLM  */
#line 1016 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHLM); }
#line 4093 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 216: /* cat3_imm_reg_opc: T_OP_SHRG  */
#line 1017 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHRG); }
#line 4099 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 217: /* cat3_imm_reg_opc: T_OP_SHLG  */
#line 1018 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHLG); }
#line 4105 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 218: /* cat3_imm_reg_opc: T_OP_ANDG  */
#line 1019 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ANDG); }
#line 4111 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 219: /* cat3_wmm: T_OP_WMM  */
#line 1021 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_WMM); }
#line 4117 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 220: /* cat3_wmm: T_OP_WMM_ACCU  */
#line 1022 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_WMM_ACCU); }
#line 4123 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 221: /* cat3_dp: T_OP_DP2ACC  */
#line 1024 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DP2ACC); }
#line 4129 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 222: /* cat3_dp: T_OP_DP4ACC  */
#line 1025 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DP4ACC); }
#line 4135 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 227: /* cat4_opc: T_OP_RCP  */
#line 1032 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RCP); }
#line 4141 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 228: /* cat4_opc: T_OP_RSQ  */
#line 1033 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RSQ); }
#line 4147 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 229: /* cat4_opc: T_OP_LOG2  */
#line 1034 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_LOG2); }
#line 4153 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 230: /* cat4_opc: T_OP_EXP2  */
#line 1035 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_EXP2); }
#line 4159 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 231: /* cat4_opc: T_OP_SIN  */
#line 1036 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SIN); }
#line 4165 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 232: /* cat4_opc: T_OP_COS  */
#line 1037 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_COS); }
#line 4171 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 233: /* cat4_opc: T_OP_SQRT  */
#line 1038 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SQRT); }
#line 4177 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 234: /* cat4_opc: T_OP_HRSQ  */
#line 1039 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HRSQ); }
#line 4183 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 235: /* cat4_opc: T_OP_HLOG2  */
#line 1040 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HLOG2); }
#line 4189 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 236: /* cat4_opc: T_OP_HEXP2  */
#line 1041 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HEXP2); }
#line 4195 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 238: /* cat5_opc_dsxypp: T_OP_DSXPP_1  */
#line 1045 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSXPP_1)->cat5.type = TYPE_F32; }
#line 4201 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 239: /* cat5_opc_dsxypp: T_OP_DSYPP_1  */
#line 1046 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSYPP_1)->cat5.type = TYPE_F32; }
#line 4207 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 240: /* cat5_opc: T_OP_ISAM  */
#line 1048 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAM); }
#line 4213 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 241: /* cat5_opc: T_OP_ISAML  */
#line 1049 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAML); }
#line 4219 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 242: /* cat5_opc: T_OP_ISAMM  */
#line 1050 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAMM); }
#line 4225 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 243: /* cat5_opc: T_OP_SAM  */
#line 1051 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAM); }
#line 4231 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 244: /* cat5_opc: T_OP_SAMB  */
#line 1052 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMB); }
#line 4237 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 245: /* cat5_opc: T_OP_SAML  */
#line 1053 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAML); }
#line 4243 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 246: /* cat5_opc: T_OP_SAMGQ  */
#line 1054 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGQ); }
#line 4249 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 247: /* cat5_opc: T_OP_GETLOD  */
#line 1055 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETLOD); }
#line 4255 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 248: /* cat5_opc: T_OP_CONV  */
#line 1056 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CONV); }
#line 4261 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 249: /* cat5_opc: T_OP_CONVM  */
#line 1057 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CONVM); }
#line 4267 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 250: /* cat5_opc: T_OP_GETSIZE  */
#line 1058 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETSIZE); }
#line 4273 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 251: /* cat5_opc: T_OP_GETBUF  */
#line 1059 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETBUF); }
#line 4279 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 252: /* cat5_opc: T_OP_GETPOS  */
#line 1060 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETPOS); }
#line 4285 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 253: /* cat5_opc: T_OP_GETINFO  */
#line 1061 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETINFO); }
#line 4291 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 254: /* cat5_opc: T_OP_DSX  */
#line 1062 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSX); }
#line 4297 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 255: /* cat5_opc: T_OP_DSY  */
#line 1063 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSY); }
#line 4303 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 256: /* cat5_opc: T_OP_GATHER4R  */
#line 1064 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4R); }
#line 4309 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 257: /* cat5_opc: T_OP_GATHER4G  */
#line 1065 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4G); }
#line 4315 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 258: /* cat5_opc: T_OP_GATHER4B  */
#line 1066 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4B); }
#line 4321 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 259: /* cat5_opc: T_OP_GATHER4A  */
#line 1067 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4A); }
#line 4327 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 260: /* cat5_opc: T_OP_SAMGP0  */
#line 1068 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP0); }
#line 4333 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 261: /* cat5_opc: T_OP_SAMGP1  */
#line 1069 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP1); }
#line 4339 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 262: /* cat5_opc: T_OP_SAMGP2  */
#line 1070 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP2); }
#line 4345 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 263: /* cat5_opc: T_OP_SAMGP3  */
#line 1071 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP3); }
#line 4351 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 264: /* cat5_opc: T_OP_RGETPOS  */
#line 1072 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RGETPOS); }
#line 4357 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 265: /* cat5_opc: T_OP_RGETINFO  */
#line 1073 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RGETINFO); }
#line 4363 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 266: /* cat5_opc: T_OP_BRCST_A  */
#line 1074 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BRCST_ACTIVE); }
#line 4369 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 267: /* cat5_opc: T_OP_QSHUFFLE_BRCST  */
#line 1075 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_BRCST); }
#line 4375 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 268: /* cat5_opc: T_OP_QSHUFFLE_H  */
#line 1076 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_HORIZ); }
#line 4381 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 269: /* cat5_opc: T_OP_QSHUFFLE_V  */
#line 1077 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_VERT); }
#line 4387 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 270: /* cat5_opc: T_OP_QSHUFFLE_DIAG  */
#line 1078 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_DIAG); }
#line 4393 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 271: /* cat5_flag: '.' T_3D  */
#line 1080 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_3D; }
#line 4399 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 272: /* cat5_flag: '.' 'a'  */
#line 1081 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_A; }
#line 4405 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 273: /* cat5_flag: '.' 'o'  */
#line 1082 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_O; }
#line 4411 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 274: /* cat5_flag: '.' 'p'  */
#line 1083 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_P; }
#line 4417 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 275: /* cat5_flag: '.' 's'  */
#line 1084 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_S; }
#line 4423 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 276: /* cat5_flag: '.' T_S2EN  */
#line 1085 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_S2EN; }
#line 4429 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 277: /* cat5_flag: '.' T_UNIFORM  */
#line 1086 "../src/freedreno/ir3/ir3_parser.y"
                                  { }
#line 4435 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 278: /* cat5_flag: '.' T_NONUNIFORM  */
#line 1087 "../src/freedreno/ir3/ir3_parser.y"
                                     { instr->flags |= IR3_INSTR_NONUNIF; }
#line 4441 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 279: /* cat5_flag: '.' T_BASE  */
#line 1088 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_B; instr->cat5.tex_base = (yyvsp[0].tok); }
#line 4447 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 280: /* cat5_flag: '.' T_W  */
#line 1089 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.cluster_size = (yyvsp[0].num); }
#line 4453 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 283: /* cat5_samp: T_SAMP  */
#line 1093 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.samp = (yyvsp[0].tok); }
#line 4459 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 284: /* cat5_tex: T_TEX  */
#line 1094 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.tex = (yyvsp[0].tok); }
#line 4465 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 285: /* cat5_type: '(' type ')'  */
#line 1095 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.type = (yyvsp[-1].type); }
#line 4471 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 286: /* cat5_a1: src_reg  */
#line 1096 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_A1EN; }
#line 4477 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 303: /* cat5_instr: T_OP_TCINV  */
#line 1114 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_TCINV); }
#line 4483 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 304: /* cat6_typed: '.' T_UNTYPED  */
#line 1116 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat6.typed = 0; }
#line 4489 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 305: /* cat6_typed: '.' T_TYPED  */
#line 1117 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat6.typed = 1; }
#line 4495 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 306: /* cat6_dim: '.' T_1D  */
#line 1119 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 1; }
#line 4501 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 307: /* cat6_dim: '.' T_2D  */
#line 1120 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 2; }
#line 4507 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 308: /* cat6_dim: '.' T_3D  */
#line 1121 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 3; }
#line 4513 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 309: /* cat6_dim: '.' T_4D  */
#line 1122 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 4; }
#line 4519 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 310: /* cat6_type: '.' type  */
#line 1124 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.type = (yyvsp[0].type); }
#line 4525 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 311: /* cat6_imm_offset: offset  */
#line 1125 "../src/freedreno/ir3/ir3_parser.y"
                             { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4531 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 314: /* cat6_dst_offset: offset  */
#line 1128 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.dst_offset = (yyvsp[0].num); }
#line 4537 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 316: /* cat6_immed: integer  */
#line 1131 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.iim_val = (yyvsp[0].num); }
#line 4543 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 317: /* cat6_a6xx_global_address_pt3: '<' '<' integer offset '<' '<' integer  */
#line 1134 "../src/freedreno/ir3/ir3_parser.y"
                                                          {
                        assert((yyvsp[0].num) == 2);
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-4].num) - 2;
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-3].num);
                   }
#line 4553 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 319: /* cat6_a6xx_global_address_pt2: '(' src offset ')' '<' '<' integer  */
#line 1142 "../src/freedreno/ir3/ir3_parser.y"
                                                      {
                        assert((yyvsp[0].num) == 2);
                        new_src(0, IR3_REG_IMMED)->uim_val = 0;
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-4].num);
                   }
#line 4563 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 322: /* $@25: %empty  */
#line 1153 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDG); }
#line 4569 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 324: /* $@26: %empty  */
#line 1154 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDG_A); }
#line 4575 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 326: /* $@27: %empty  */
#line 1155 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDP); }
#line 4581 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 328: /* $@28: %empty  */
#line 1156 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDL); }
#line 4587 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 330: /* $@29: %empty  */
#line 1157 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDLW); }
#line 4593 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 332: /* $@30: %empty  */
#line 1158 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDLV); }
#line 4599 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 333: /* $@31: %empty  */
#line 1158 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                  {
                       new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[-1].num);
                   }
#line 4607 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 335: /* $@32: %empty  */
#line 1162 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_STG); dummy_dst(); }
#line 4613 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 337: /* $@33: %empty  */
#line 1163 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_STG_A); dummy_dst(); }
#line 4619 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 339: /* $@34: %empty  */
#line 1164 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STP); dummy_dst(); }
#line 4625 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 341: /* $@35: %empty  */
#line 1165 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STL); dummy_dst(); }
#line 4631 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 343: /* $@36: %empty  */
#line 1166 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STLW); dummy_dst(); }
#line 4637 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 345: /* $@37: %empty  */
#line 1168 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_LDIB); }
#line 4643 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 347: /* $@38: %empty  */
#line 1169 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STIB); dummy_dst(); }
#line 4649 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 349: /* $@39: %empty  */
#line 1171 "../src/freedreno/ir3/ir3_parser.y"
                                 { new_instr(OPC_PREFETCH); new_dst(0,0); /* dummy dst */ }
#line 4655 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 351: /* cat6_atomic_opc: T_OP_ATOMIC_ADD  */
#line 1173 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_ADD); }
#line 4661 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 352: /* cat6_atomic_opc: T_OP_ATOMIC_SUB  */
#line 1174 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_SUB); }
#line 4667 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 353: /* cat6_atomic_opc: T_OP_ATOMIC_XCHG  */
#line 1175 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_XCHG); }
#line 4673 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 354: /* cat6_atomic_opc: T_OP_ATOMIC_INC  */
#line 1176 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_INC); }
#line 4679 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 355: /* cat6_atomic_opc: T_OP_ATOMIC_DEC  */
#line 1177 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_DEC); }
#line 4685 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 356: /* cat6_atomic_opc: T_OP_ATOMIC_CMPXCHG  */
#line 1178 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_CMPXCHG); }
#line 4691 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 357: /* cat6_atomic_opc: T_OP_ATOMIC_MIN  */
#line 1179 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_MIN); }
#line 4697 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 358: /* cat6_atomic_opc: T_OP_ATOMIC_MAX  */
#line 1180 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_MAX); }
#line 4703 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 359: /* cat6_atomic_opc: T_OP_ATOMIC_AND  */
#line 1181 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_AND); }
#line 4709 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 360: /* cat6_atomic_opc: T_OP_ATOMIC_OR  */
#line 1182 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_OR); }
#line 4715 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 361: /* cat6_atomic_opc: T_OP_ATOMIC_XOR  */
#line 1183 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_XOR); }
#line 4721 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 362: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_ADD  */
#line 1185 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_ADD); }
#line 4727 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 363: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_SUB  */
#line 1186 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_SUB); }
#line 4733 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 364: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_XCHG  */
#line 1187 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_XCHG); }
#line 4739 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 365: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_INC  */
#line 1188 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_INC); }
#line 4745 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 366: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_DEC  */
#line 1189 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_DEC); }
#line 4751 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 367: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_CMPXCHG  */
#line 1190 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_CMPXCHG); }
#line 4757 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 368: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_MIN  */
#line 1191 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_MIN); }
#line 4763 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 369: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_MAX  */
#line 1192 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_MAX); }
#line 4769 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 370: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_AND  */
#line 1193 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_AND); }
#line 4775 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 371: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_OR  */
#line 1194 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_OR); }
#line 4781 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 372: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_XOR  */
#line 1195 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_XOR); }
#line 4787 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 373: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_ADD  */
#line 1197 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_ADD); }
#line 4793 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 374: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_SUB  */
#line 1198 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_SUB); }
#line 4799 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 375: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_XCHG  */
#line 1199 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_XCHG); }
#line 4805 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 376: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_INC  */
#line 1200 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_INC); }
#line 4811 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 377: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_DEC  */
#line 1201 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_DEC); }
#line 4817 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 378: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_CMPXCHG  */
#line 1202 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_CMPXCHG); }
#line 4823 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 379: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_MIN  */
#line 1203 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_MIN); }
#line 4829 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 380: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_MAX  */
#line 1204 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_MAX); }
#line 4835 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 381: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_AND  */
#line 1205 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_AND); }
#line 4841 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 382: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_OR  */
#line 1206 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_OR); }
#line 4847 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 383: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_XOR  */
#line 1207 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_XOR); }
#line 4853 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 390: /* cat6_ibo_opc_1src: T_OP_RESINFO  */
#line 1219 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RESINFO); }
#line 4859 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 391: /* cat6_ibo_opc_ldgb: T_OP_LDGB  */
#line 1221 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_LDGB); }
#line 4865 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 392: /* cat6_ibo_opc_stgb: T_OP_STGB  */
#line 1222 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_STGB); }
#line 4871 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 395: /* $@40: %empty  */
#line 1226 "../src/freedreno/ir3/ir3_parser.y"
                                                                                  { dummy_dst(); }
#line 4877 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 397: /* cat6_id_opc: T_OP_GETSPID  */
#line 1229 "../src/freedreno/ir3/ir3_parser.y"
                                { new_instr(OPC_GETSPID); }
#line 4883 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 398: /* cat6_id_opc: T_OP_GETWID  */
#line 1230 "../src/freedreno/ir3/ir3_parser.y"
                                { new_instr(OPC_GETWID); }
#line 4889 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 399: /* cat6_id_opc: T_OP_GETFIBERID  */
#line 1231 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_GETFIBERID); }
#line 4895 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 402: /* cat6_bindless_base: '.' T_BASE  */
#line 1236 "../src/freedreno/ir3/ir3_parser.y"
                              { instr->flags |= IR3_INSTR_B; instr->cat6.base = (yyvsp[0].tok); }
#line 4901 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 405: /* cat6_bindless_mode: T_NONUNIFORM cat6_bindless_base  */
#line 1240 "../src/freedreno/ir3/ir3_parser.y"
                                                   { instr->flags |= IR3_INSTR_NONUNIF; }
#line 4907 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 407: /* cat6_reg_or_immed: integer  */
#line 1243 "../src/freedreno/ir3/ir3_parser.y"
                           { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4913 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 408: /* cat6_bindless_ibo_opc_1src: T_OP_RESINFO_B  */
#line 1245 "../src/freedreno/ir3/ir3_parser.y"
                                                 { new_instr(OPC_RESINFO); }
#line 4919 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 409: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_ADD  */
#line 1247 "../src/freedreno/ir3/ir3_parser.y"
                                                     { new_instr(OPC_ATOMIC_B_ADD); dummy_dst(); }
#line 4925 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 410: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_SUB  */
#line 1248 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_SUB); dummy_dst(); }
#line 4931 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 411: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_XCHG  */
#line 1249 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_XCHG); dummy_dst(); }
#line 4937 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 412: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_INC  */
#line 1250 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_INC); dummy_dst(); }
#line 4943 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 413: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_DEC  */
#line 1251 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_DEC); dummy_dst(); }
#line 4949 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 414: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_CMPXCHG  */
#line 1252 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_CMPXCHG); dummy_dst(); }
#line 4955 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 415: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_MIN  */
#line 1253 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_MIN); dummy_dst(); }
#line 4961 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 416: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_MAX  */
#line 1254 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_MAX); dummy_dst(); }
#line 4967 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 417: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_AND  */
#line 1255 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_AND); dummy_dst(); }
#line 4973 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 418: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_OR  */
#line 1256 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_OR); dummy_dst(); }
#line 4979 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 419: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_XOR  */
#line 1257 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_XOR); dummy_dst(); }
#line 4985 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 420: /* cat6_bindless_ibo_opc_2src: T_OP_STIB_B  */
#line 1258 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_STIB); dummy_dst(); }
#line 4991 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 421: /* cat6_bindless_ibo_opc_2src_dst: T_OP_LDIB_B  */
#line 1260 "../src/freedreno/ir3/ir3_parser.y"
                                                         { new_instr(OPC_LDIB); }
#line 4997 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 423: /* cat6_bindless_ibo: cat6_bindless_ibo_opc_2src cat6_typed cat6_dim cat6_type '.' cat6_immed '.' cat6_bindless_mode src_reg ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1263 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                                      { swap(instr->srcs[0], instr->srcs[2]); }
#line 5003 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 424: /* cat6_bindless_ibo: cat6_bindless_ibo_opc_2src_dst cat6_typed cat6_dim cat6_type '.' cat6_immed '.' cat6_bindless_mode dst_reg ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1264 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                                          { swap(instr->srcs[0], instr->srcs[1]); }
#line 5009 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 425: /* cat6_bindless_ldc_opc: T_OP_LDC  */
#line 1266 "../src/freedreno/ir3/ir3_parser.y"
                                 { new_instr(OPC_LDC); }
#line 5015 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 426: /* cat6_bindless_ldc_middle: T_OFFSET '.' cat6_immed '.' cat6_bindless_mode dst_reg  */
#line 1270 "../src/freedreno/ir3/ir3_parser.y"
                                                                               { instr->cat6.d = (yyvsp[-5].tok); }
#line 5021 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 427: /* cat6_bindless_ldc_middle: cat6_immed '.' 'k' '.' cat6_bindless_mode 'c' '[' T_A1 ']'  */
#line 1271 "../src/freedreno/ir3/ir3_parser.y"
                                                                                   { instr->opc = OPC_LDC_K; }
#line 5027 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 428: /* cat6_bindless_ldc: cat6_bindless_ldc_opc '.' cat6_bindless_ldc_middle ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1273 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                  {
                      instr->cat6.type = TYPE_U32;
                      /* TODO cleanup ir3 src order: */
                      swap(instr->srcs[0], instr->srcs[1]);
                   }
#line 5037 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 429: /* stc_dst: integer  */
#line 1279 "../src/freedreno/ir3/ir3_parser.y"
                          { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 5043 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 430: /* stc_dst: T_A1  */
#line 1280 "../src/freedreno/ir3/ir3_parser.y"
                       { new_src(0, IR3_REG_IMMED)->iim_val = 0; instr->flags |= IR3_INSTR_A1EN; }
#line 5049 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 431: /* stc_dst: T_A1 '+' integer  */
#line 1281 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); instr->flags |= IR3_INSTR_A1EN; }
#line 5055 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 432: /* $@41: %empty  */
#line 1284 "../src/freedreno/ir3/ir3_parser.y"
                        { new_instr(OPC_STC); }
#line 5061 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 434: /* $@42: %empty  */
#line 1285 "../src/freedreno/ir3/ir3_parser.y"
                        { new_instr(OPC_STSC); }
#line 5067 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 436: /* cat6_todo: T_OP_G2L  */
#line 1287 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_G2L); }
#line 5073 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 437: /* cat6_todo: T_OP_L2G  */
#line 1288 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_L2G); }
#line 5079 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 438: /* cat6_todo: T_OP_RESFMT  */
#line 1289 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_RESFMT); }
#line 5085 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 451: /* cat7_scope: '.' 'w'  */
#line 1304 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.w = true; }
#line 5091 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 452: /* cat7_scope: '.' 'r'  */
#line 1305 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.r = true; }
#line 5097 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 453: /* cat7_scope: '.' 'l'  */
#line 1306 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.l = true; }
#line 5103 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 454: /* cat7_scope: '.' 'g'  */
#line 1307 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.g = true; }
#line 5109 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 457: /* $@43: %empty  */
#line 1312 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_BAR); }
#line 5115 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 459: /* $@44: %empty  */
#line 1313 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_FENCE); }
#line 5121 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 461: /* cat7_data_cache: T_OP_DCCLN  */
#line 1315 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_DCCLN); }
#line 5127 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 462: /* cat7_data_cache: T_OP_DCINV  */
#line 1316 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_DCINV); }
#line 5133 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 463: /* cat7_data_cache: T_OP_DCFLU  */
#line 1317 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_DCFLU); }
#line 5139 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 466: /* cat7_alias_scope: T_MOD_TEX  */
#line 1322 "../src/freedreno/ir3/ir3_parser.y"
                                { instr->cat7.alias_scope = ALIAS_TEX; }
#line 5145 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 467: /* cat7_alias_scope: T_MOD_MEM  */
#line 1323 "../src/freedreno/ir3/ir3_parser.y"
                                { instr->cat7.alias_scope = ALIAS_MEM; }
#line 5151 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 468: /* cat7_alias_scope: T_MOD_RT  */
#line 1324 "../src/freedreno/ir3/ir3_parser.y"
                                { instr->cat7.alias_scope = ALIAS_RT; }
#line 5157 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 471: /* cat7_instr: T_OP_SLEEP  */
#line 1328 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_SLEEP); }
#line 5163 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 472: /* cat7_instr: T_OP_ICINV  */
#line 1329 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_ICINV); }
#line 5169 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 473: /* cat7_instr: T_OP_LOCK  */
#line 1330 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_LOCK); }
#line 5175 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 474: /* cat7_instr: T_OP_UNLOCK  */
#line 1331 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_UNLOCK); }
#line 5181 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 475: /* $@45: %empty  */
#line 1332 "../src/freedreno/ir3/ir3_parser.y"
                              {
                       /* TODO: handle T_INSTR_TYPE */
                       new_instr(OPC_ALIAS);
                   }
#line 5190 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 476: /* cat7_instr: T_OP_ALIAS $@45 '.' cat7_alias_scope '.' T_INSTR_TYPE '.' integer dst_reg ',' cat7_alias_src  */
#line 1335 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                  {
                       new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-3].num);
                   }
#line 5198 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 477: /* raw_instr: T_RAW  */
#line 1339 "../src/freedreno/ir3/ir3_parser.y"
                   {new_instr(OPC_META_RAW)->raw.value = (yyvsp[0].u64);}
#line 5204 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 478: /* src: T_REGISTER  */
#line 1341 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((yyvsp[0].num), 0); }
#line 5210 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 479: /* src: T_A0  */
#line 1342 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((61 << 3), IR3_REG_HALF); }
#line 5216 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 480: /* src: T_A1  */
#line 1343 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((61 << 3) + 1, IR3_REG_HALF); }
#line 5222 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 481: /* src: T_P0  */
#line 1344 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((62 << 3) + (yyvsp[0].num), 0); }
#line 5228 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 482: /* dst: T_REGISTER  */
#line 1346 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((yyvsp[0].num), 0); }
#line 5234 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 483: /* dst: T_A0  */
#line 1347 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((61 << 3), IR3_REG_HALF); }
#line 5240 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 484: /* dst: T_A1  */
#line 1348 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((61 << 3) + 1, IR3_REG_HALF); }
#line 5246 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 485: /* dst: T_P0  */
#line 1349 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((62 << 3) + (yyvsp[0].num), 0); }
#line 5252 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 486: /* const: T_CONSTANT  */
#line 1351 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((yyvsp[0].num), IR3_REG_CONST); }
#line 5258 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 487: /* dst_reg_flag: T_EVEN  */
#line 1353 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_EVEN; }
#line 5264 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 488: /* dst_reg_flag: T_POS_INFINITY  */
#line 1354 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_POS_INF; }
#line 5270 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 489: /* dst_reg_flag: T_NEG_INFINITY  */
#line 1355 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_NEG_INF; }
#line 5276 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 490: /* dst_reg_flag: T_EI  */
#line 1356 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_EI; }
#line 5282 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 491: /* dst_reg_flag: T_WRMASK  */
#line 1357 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.wrmask = (yyvsp[0].num); }
#line 5288 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 494: /* dst_reg: dst  */
#line 1363 "../src/freedreno/ir3/ir3_parser.y"
                                       { (yyvsp[0].reg)->flags |= IR3_REG_R; }
#line 5294 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 495: /* dst_reg: dst_reg_flags dst  */
#line 1364 "../src/freedreno/ir3/ir3_parser.y"
                                       { (yyvsp[0].reg)->flags |= IR3_REG_R; }
#line 5300 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 496: /* src_reg_flag: T_ABSNEG  */
#line 1366 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_ABS|IR3_REG_NEGATE; }
#line 5306 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 497: /* src_reg_flag: T_NEG  */
#line 1367 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_NEGATE; }
#line 5312 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 498: /* src_reg_flag: T_ABS  */
#line 1368 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_ABS; }
#line 5318 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 499: /* src_reg_flag: T_R  */
#line 1369 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_R; }
#line 5324 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 500: /* src_reg_flag: T_LAST  */
#line 1370 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_LAST_USE; }
#line 5330 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 520: /* offset: %empty  */
#line 1399 "../src/freedreno/ir3/ir3_parser.y"
                   { (yyval.num) = 0; }
#line 5336 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 521: /* offset: '+' integer  */
#line 1400 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].num); }
#line 5342 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 522: /* offset: '-' integer  */
#line 1401 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].num); }
#line 5348 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 523: /* relative_gpr_src: 'r' '<' T_A0 offset '>'  */
#line 1403 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_src(0, IR3_REG_RELATIV)->array.offset = (yyvsp[-1].num); }
#line 5354 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 524: /* relative_gpr_src: T_HR '<' T_A0 offset '>'  */
#line 1404 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_src(0, IR3_REG_RELATIV | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 5360 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 525: /* relative_gpr_dst: 'r' '<' T_A0 offset '>'  */
#line 1406 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_dst(0, IR3_REG_RELATIV)->array.offset = (yyvsp[-1].num); }
#line 5366 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 526: /* relative_gpr_dst: T_HR '<' T_A0 offset '>'  */
#line 1407 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_dst(0, IR3_REG_RELATIV | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 5372 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 527: /* relative_const: 'c' '<' T_A0 offset '>'  */
#line 1409 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_src(0, IR3_REG_RELATIV | IR3_REG_CONST)->array.offset = (yyvsp[-1].num); }
#line 5378 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 528: /* relative_const: T_HC '<' T_A0 offset '>'  */
#line 1410 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_src(0, IR3_REG_RELATIV | IR3_REG_CONST | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 5384 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 531: /* immediate_cat1: integer  */
#line 1419 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->iim_val = type_size(instr->cat1.src_type) < 32 ? (yyvsp[0].num) & 0xffff : (yyvsp[0].num); }
#line 5390 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 532: /* immediate_cat1: '(' integer ')'  */
#line 1420 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].num); }
#line 5396 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 533: /* immediate_cat1: '(' float ')'  */
#line 1421 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].flt); }
#line 5402 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 534: /* immediate_cat1: 'h' '(' integer ')'  */
#line 1422 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->iim_val = (yyvsp[-1].num) & 0xffff; }
#line 5408 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 535: /* immediate_cat1: 'h' '(' float ')'  */
#line 1423 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->uim_val = _mesa_float_to_half((yyvsp[-1].flt)); }
#line 5414 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 536: /* immediate_cat1: '(' T_NAN ')'  */
#line 1424 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = NAN; }
#line 5420 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 537: /* immediate_cat1: '(' T_INF ')'  */
#line 1425 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = INFINITY; }
#line 5426 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 538: /* immediate: integer  */
#line 1427 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 5432 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 539: /* immediate: '(' integer ')'  */
#line 1428 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].num); }
#line 5438 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 540: /* immediate: flut_immed  */
#line 1429 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[0].num); }
#line 5444 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 541: /* immediate: 'h' '(' integer ')'  */
#line 1430 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->iim_val = (yyvsp[-1].num); }
#line 5450 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 542: /* immediate: 'h' flut_immed  */
#line 1431 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->uim_val = (yyvsp[0].num); }
#line 5456 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 555: /* integer: T_INT  */
#line 1447 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].num); }
#line 5462 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 556: /* integer: '-' T_INT  */
#line 1448 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].num); }
#line 5468 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 557: /* integer: T_HEX  */
#line 1449 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].unum); }
#line 5474 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 558: /* integer: '-' T_HEX  */
#line 1450 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].unum); }
#line 5480 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 559: /* float: T_FLOAT  */
#line 1452 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.flt) = (yyvsp[0].flt); }
#line 5486 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 560: /* float: '-' T_FLOAT  */
#line 1453 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.flt) = -(yyvsp[0].flt); }
#line 5492 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 561: /* type: T_TYPE_F16  */
#line 1455 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_F16; }
#line 5498 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 562: /* type: T_TYPE_F32  */
#line 1456 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_F32; }
#line 5504 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 563: /* type: T_TYPE_U16  */
#line 1457 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_U16; }
#line 5510 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 564: /* type: T_TYPE_U32  */
#line 1458 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_U32; }
#line 5516 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 565: /* type: T_TYPE_S16  */
#line 1459 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_S16; }
#line 5522 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 566: /* type: T_TYPE_S32  */
#line 1460 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_S32; }
#line 5528 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 567: /* type: T_TYPE_U8  */
#line 1461 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_U8;  }
#line 5534 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 568: /* type: T_TYPE_S8  */
#line 1462 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_S8;  }
#line 5540 "src/freedreno/ir3/ir3_parser.c"
    break;


#line 5544 "src/freedreno/ir3/ir3_parser.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

